/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_CLOWNFISH_STRING
#define H_CLOWNFISH_STRING 1


#ifdef __cplusplus
extern "C" {
#endif

#include "cfish_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Clownfish/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_CFISH_STRING
extern size_t cfish_Str_IVARS_OFFSET;
typedef struct cfish_StringIVARS cfish_StringIVARS;
static CFISH_INLINE cfish_StringIVARS*
cfish_Str_IVARS(cfish_String *self) {
   char *ptr = (char*)self + cfish_Str_IVARS_OFFSET;
   return (cfish_StringIVARS*)ptr;
}
#ifdef CFISH_USE_SHORT_NAMES
  #define StringIVARS cfish_StringIVARS
  #define Str_IVARS cfish_Str_IVARS
#endif

struct cfish_String {
    CFISH_OBJ_HEAD
    cfish_Class* klass;
    const char* ptr;
    size_t size;
    cfish_String* origin;
};

#endif /* C_CFISH_STRING */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

CFISH_VISIBLE cfish_String*
cfish_Str_new_from_utf8(const char* utf8, size_t size);

CFISH_VISIBLE cfish_String*
cfish_Str_new_from_trusted_utf8(const char* utf8, size_t size);

CFISH_VISIBLE cfish_String*
cfish_Str_init_from_trusted_utf8(cfish_String* self, const char* utf8, size_t size);

CFISH_VISIBLE cfish_String*
cfish_Str_new_steal_utf8(char* utf8, size_t size);

CFISH_VISIBLE cfish_String*
cfish_Str_new_steal_trusted_utf8(char* utf8, size_t size);

CFISH_VISIBLE cfish_String*
cfish_Str_init_steal_trusted_utf8(cfish_String* self, char* utf8, size_t size);

CFISH_VISIBLE cfish_String*
cfish_Str_new_wrap_utf8(const char* utf8, size_t size);

CFISH_VISIBLE cfish_String*
cfish_Str_new_wrap_trusted_utf8(const char* utf8, size_t size);

CFISH_VISIBLE cfish_String*
cfish_Str_init_wrap_trusted_utf8(cfish_String* self, const char* utf8, size_t size);

CFISH_VISIBLE cfish_String*
cfish_Str_new_from_char(int32_t code_point);

CFISH_VISIBLE cfish_String*
cfish_Str_newf(const char* pattern, ...);

CFISH_VISIBLE int
cfish_Str_compare(const void* va, const void* vb);

CFISH_VISIBLE bool
cfish_Str_less_than(const void* va, const void* vb);

cfish_Obj*
CFISH_Str_Inc_RefCount_IMP(cfish_String* self);

cfish_String*
CFISH_Str_Clone_IMP(cfish_String* self);

void
CFISH_Str_Destroy_IMP(cfish_String* self);

bool
CFISH_Str_Equals_IMP(cfish_String* self, cfish_Obj* other);

int32_t
CFISH_Str_Compare_To_IMP(cfish_String* self, cfish_Obj* other);

int32_t
CFISH_Str_Hash_Sum_IMP(cfish_String* self);

cfish_String*
CFISH_Str_To_String_IMP(cfish_String* self);

int64_t
CFISH_Str_To_I64_IMP(cfish_String* self);

double
CFISH_Str_To_F64_IMP(cfish_String* self);

cfish_String*
CFISH_Str_Cat_IMP(cfish_String* self, cfish_String* other);

cfish_String*
CFISH_Str_Cat_Utf8_IMP(cfish_String* self, const char* ptr, size_t size);

cfish_String*
CFISH_Str_Cat_Trusted_Utf8_IMP(cfish_String* self, const char* ptr, size_t size);

cfish_String*
CFISH_Str_Swap_Chars_IMP(cfish_String* self, int32_t match, int32_t replacement);

int64_t
CFISH_Str_BaseX_To_I64_IMP(cfish_String* self, uint32_t base);

bool
CFISH_Str_Starts_With_IMP(cfish_String* self, cfish_String* prefix);

bool
CFISH_Str_Starts_With_Utf8_IMP(cfish_String* self, const char* prefix, size_t size);

bool
CFISH_Str_Ends_With_IMP(cfish_String* self, cfish_String* postfix);

bool
CFISH_Str_Ends_With_Utf8_IMP(cfish_String* self, const char* postfix, size_t size);

int64_t
CFISH_Str_Find_IMP(cfish_String* self, cfish_String* substring);

int64_t
CFISH_Str_Find_Utf8_IMP(cfish_String* self, const char* ptr, size_t size);

bool
CFISH_Str_Equals_Utf8_IMP(cfish_String* self, const char* ptr, size_t size);

size_t
CFISH_Str_Length_IMP(cfish_String* self);

size_t
CFISH_Str_Get_Size_IMP(cfish_String* self);

const char*
CFISH_Str_Get_Ptr8_IMP(cfish_String* self);

char*
CFISH_Str_To_Utf8_IMP(cfish_String* self);

cfish_String*
CFISH_Str_Trim_IMP(cfish_String* self);

cfish_String*
CFISH_Str_Trim_Top_IMP(cfish_String* self);

cfish_String*
CFISH_Str_Trim_Tail_IMP(cfish_String* self);

int32_t
CFISH_Str_Code_Point_At_IMP(cfish_String* self, size_t tick);

int32_t
CFISH_Str_Code_Point_From_IMP(cfish_String* self, size_t tick);

cfish_String*
CFISH_Str_SubString_IMP(cfish_String* self, size_t offset, size_t len);

cfish_StringIterator*
CFISH_Str_Top_IMP(cfish_String* self);

cfish_StringIterator*
CFISH_Str_Tail_IMP(cfish_String* self);

cfish_StackStringIterator*
CFISH_Str_StackTop_IMP(cfish_String* self, void* allocation);

cfish_StackStringIterator*
CFISH_Str_StackTail_IMP(cfish_String* self, void* allocation);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*CFISH_Str_Get_RefCount_t)(cfish_String *self);

typedef cfish_Obj*
(*CFISH_Str_Inc_RefCount_t)(cfish_String *self);

typedef uint32_t
(*CFISH_Str_Dec_RefCount_t)(cfish_String *self);

typedef void*
(*CFISH_Str_To_Host_t)(cfish_String *self);

typedef cfish_String*
(*CFISH_Str_Clone_t)(cfish_String *self);

typedef void
(*CFISH_Str_Destroy_t)(cfish_String *self);

typedef bool
(*CFISH_Str_Equals_t)(cfish_String *self, cfish_Obj* other);

typedef int32_t
(*CFISH_Str_Compare_To_t)(cfish_String *self, cfish_Obj* other);

typedef int32_t
(*CFISH_Str_Hash_Sum_t)(cfish_String *self);

typedef cfish_Class*
(*CFISH_Str_Get_Class_t)(cfish_String *self);

typedef cfish_String*
(*CFISH_Str_Get_Class_Name_t)(cfish_String *self);

typedef bool
(*CFISH_Str_Is_A_t)(cfish_String *self, cfish_Class* ancestor);

typedef cfish_String*
(*CFISH_Str_To_String_t)(cfish_String *self);

typedef int64_t
(*CFISH_Str_To_I64_t)(cfish_String *self);

typedef double
(*CFISH_Str_To_F64_t)(cfish_String *self);

typedef bool
(*CFISH_Str_To_Bool_t)(cfish_String *self);

typedef void
(*CFISH_Str_Mimic_t)(cfish_String *self, cfish_Obj* other);

typedef cfish_String*
(*CFISH_Str_Cat_t)(cfish_String *self, cfish_String* other);

typedef cfish_String*
(*CFISH_Str_Cat_Utf8_t)(cfish_String *self, const char* ptr, size_t size);

typedef cfish_String*
(*CFISH_Str_Cat_Trusted_Utf8_t)(cfish_String *self, const char* ptr, size_t size);

typedef cfish_String*
(*CFISH_Str_Swap_Chars_t)(cfish_String *self, int32_t match, int32_t replacement);

typedef int64_t
(*CFISH_Str_BaseX_To_I64_t)(cfish_String *self, uint32_t base);

typedef bool
(*CFISH_Str_Starts_With_t)(cfish_String *self, cfish_String* prefix);

typedef bool
(*CFISH_Str_Starts_With_Utf8_t)(cfish_String *self, const char* prefix, size_t size);

typedef bool
(*CFISH_Str_Ends_With_t)(cfish_String *self, cfish_String* postfix);

typedef bool
(*CFISH_Str_Ends_With_Utf8_t)(cfish_String *self, const char* postfix, size_t size);

typedef int64_t
(*CFISH_Str_Find_t)(cfish_String *self, cfish_String* substring);

typedef int64_t
(*CFISH_Str_Find_Utf8_t)(cfish_String *self, const char* ptr, size_t size);

typedef bool
(*CFISH_Str_Equals_Utf8_t)(cfish_String *self, const char* ptr, size_t size);

typedef size_t
(*CFISH_Str_Length_t)(cfish_String *self);

typedef size_t
(*CFISH_Str_Get_Size_t)(cfish_String *self);

typedef const char*
(*CFISH_Str_Get_Ptr8_t)(cfish_String *self);

typedef char*
(*CFISH_Str_To_Utf8_t)(cfish_String *self);

typedef cfish_String*
(*CFISH_Str_Trim_t)(cfish_String *self);

typedef cfish_String*
(*CFISH_Str_Trim_Top_t)(cfish_String *self);

typedef cfish_String*
(*CFISH_Str_Trim_Tail_t)(cfish_String *self);

typedef int32_t
(*CFISH_Str_Code_Point_At_t)(cfish_String *self, size_t tick);

typedef int32_t
(*CFISH_Str_Code_Point_From_t)(cfish_String *self, size_t tick);

typedef cfish_String*
(*CFISH_Str_SubString_t)(cfish_String *self, size_t offset, size_t len);

typedef cfish_StringIterator*
(*CFISH_Str_Top_t)(cfish_String *self);

typedef cfish_StringIterator*
(*CFISH_Str_Tail_t)(cfish_String *self);

typedef cfish_StackStringIterator*
(*CFISH_Str_StackTop_t)(cfish_String *self, void* allocation);

typedef cfish_StackStringIterator*
(*CFISH_Str_StackTail_t)(cfish_String *self, void* allocation);



/* Define the inline functions which implement this class's virtual methods.
 */

extern CFISH_VISIBLE size_t CFISH_Str_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_Str_Get_RefCount(cfish_String *self) {
    const CFISH_Str_Get_RefCount_t method = (CFISH_Str_Get_RefCount_t)cfish_obj_method(self, CFISH_Str_Get_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Str_Inc_RefCount(cfish_String *self) {
    const CFISH_Str_Inc_RefCount_t method = (CFISH_Str_Inc_RefCount_t)cfish_obj_method(self, CFISH_Str_Inc_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_Str_Dec_RefCount(cfish_String *self) {
    const CFISH_Str_Dec_RefCount_t method = (CFISH_Str_Dec_RefCount_t)cfish_obj_method(self, CFISH_Str_Dec_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_To_Host_OFFSET;
static CFISH_INLINE void*
CFISH_Str_To_Host(cfish_String *self) {
    const CFISH_Str_To_Host_t method = (CFISH_Str_To_Host_t)cfish_obj_method(self, CFISH_Str_To_Host_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Clone_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Str_Clone(cfish_String *self) {
    const CFISH_Str_Clone_t method = (CFISH_Str_Clone_t)cfish_obj_method(self, CFISH_Str_Clone_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Destroy_OFFSET;
static CFISH_INLINE void
CFISH_Str_Destroy(cfish_String *self) {
    const CFISH_Str_Destroy_t method = (CFISH_Str_Destroy_t)cfish_obj_method(self, CFISH_Str_Destroy_OFFSET);
    method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Equals_OFFSET;
static CFISH_INLINE bool
CFISH_Str_Equals(cfish_String *self, cfish_Obj* other) {
    const CFISH_Str_Equals_t method = (CFISH_Str_Equals_t)cfish_obj_method(self, CFISH_Str_Equals_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_Str_Compare_To_OFFSET;
static CFISH_INLINE int32_t
CFISH_Str_Compare_To(cfish_String *self, cfish_Obj* other) {
    const CFISH_Str_Compare_To_t method = (CFISH_Str_Compare_To_t)cfish_obj_method(self, CFISH_Str_Compare_To_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_Str_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
CFISH_Str_Hash_Sum(cfish_String *self) {
    const CFISH_Str_Hash_Sum_t method = (CFISH_Str_Hash_Sum_t)cfish_obj_method(self, CFISH_Str_Hash_Sum_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
CFISH_Str_Get_Class(cfish_String *self) {
    const CFISH_Str_Get_Class_t method = (CFISH_Str_Get_Class_t)cfish_obj_method(self, CFISH_Str_Get_Class_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Str_Get_Class_Name(cfish_String *self) {
    const CFISH_Str_Get_Class_Name_t method = (CFISH_Str_Get_Class_Name_t)cfish_obj_method(self, CFISH_Str_Get_Class_Name_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Is_A_OFFSET;
static CFISH_INLINE bool
CFISH_Str_Is_A(cfish_String *self, cfish_Class* ancestor) {
    const CFISH_Str_Is_A_t method = (CFISH_Str_Is_A_t)cfish_obj_method(self, CFISH_Str_Is_A_OFFSET);
    return method(self, ancestor);
}

extern CFISH_VISIBLE size_t CFISH_Str_To_String_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Str_To_String(cfish_String *self) {
    const CFISH_Str_To_String_t method = (CFISH_Str_To_String_t)cfish_obj_method(self, CFISH_Str_To_String_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_To_I64_OFFSET;
static CFISH_INLINE int64_t
CFISH_Str_To_I64(cfish_String *self) {
    const CFISH_Str_To_I64_t method = (CFISH_Str_To_I64_t)cfish_obj_method(self, CFISH_Str_To_I64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_To_F64_OFFSET;
static CFISH_INLINE double
CFISH_Str_To_F64(cfish_String *self) {
    const CFISH_Str_To_F64_t method = (CFISH_Str_To_F64_t)cfish_obj_method(self, CFISH_Str_To_F64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_To_Bool_OFFSET;
static CFISH_INLINE bool
CFISH_Str_To_Bool(cfish_String *self) {
    const CFISH_Str_To_Bool_t method = (CFISH_Str_To_Bool_t)cfish_obj_method(self, CFISH_Str_To_Bool_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Mimic_OFFSET;
static CFISH_INLINE void
CFISH_Str_Mimic(cfish_String *self, cfish_Obj* other) {
    const CFISH_Str_Mimic_t method = (CFISH_Str_Mimic_t)cfish_obj_method(self, CFISH_Str_Mimic_OFFSET);
    method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_Str_Cat_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Str_Cat(cfish_String *self, cfish_String* other) {
    const CFISH_Str_Cat_t method = (CFISH_Str_Cat_t)cfish_obj_method(self, CFISH_Str_Cat_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_Str_Cat_Utf8_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Str_Cat_Utf8(cfish_String *self, const char* ptr, size_t size) {
    const CFISH_Str_Cat_Utf8_t method = (CFISH_Str_Cat_Utf8_t)cfish_obj_method(self, CFISH_Str_Cat_Utf8_OFFSET);
    return method(self, ptr, size);
}

extern CFISH_VISIBLE size_t CFISH_Str_Cat_Trusted_Utf8_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Str_Cat_Trusted_Utf8(cfish_String *self, const char* ptr, size_t size) {
    const CFISH_Str_Cat_Trusted_Utf8_t method = (CFISH_Str_Cat_Trusted_Utf8_t)cfish_obj_method(self, CFISH_Str_Cat_Trusted_Utf8_OFFSET);
    return method(self, ptr, size);
}

extern CFISH_VISIBLE size_t CFISH_Str_Swap_Chars_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Str_Swap_Chars(cfish_String *self, int32_t match, int32_t replacement) {
    const CFISH_Str_Swap_Chars_t method = (CFISH_Str_Swap_Chars_t)cfish_obj_method(self, CFISH_Str_Swap_Chars_OFFSET);
    return method(self, match, replacement);
}

extern CFISH_VISIBLE size_t CFISH_Str_BaseX_To_I64_OFFSET;
static CFISH_INLINE int64_t
CFISH_Str_BaseX_To_I64(cfish_String *self, uint32_t base) {
    const CFISH_Str_BaseX_To_I64_t method = (CFISH_Str_BaseX_To_I64_t)cfish_obj_method(self, CFISH_Str_BaseX_To_I64_OFFSET);
    return method(self, base);
}

extern CFISH_VISIBLE size_t CFISH_Str_Starts_With_OFFSET;
static CFISH_INLINE bool
CFISH_Str_Starts_With(cfish_String *self, cfish_String* prefix) {
    const CFISH_Str_Starts_With_t method = (CFISH_Str_Starts_With_t)cfish_obj_method(self, CFISH_Str_Starts_With_OFFSET);
    return method(self, prefix);
}

extern CFISH_VISIBLE size_t CFISH_Str_Starts_With_Utf8_OFFSET;
static CFISH_INLINE bool
CFISH_Str_Starts_With_Utf8(cfish_String *self, const char* prefix, size_t size) {
    const CFISH_Str_Starts_With_Utf8_t method = (CFISH_Str_Starts_With_Utf8_t)cfish_obj_method(self, CFISH_Str_Starts_With_Utf8_OFFSET);
    return method(self, prefix, size);
}

extern CFISH_VISIBLE size_t CFISH_Str_Ends_With_OFFSET;
static CFISH_INLINE bool
CFISH_Str_Ends_With(cfish_String *self, cfish_String* postfix) {
    const CFISH_Str_Ends_With_t method = (CFISH_Str_Ends_With_t)cfish_obj_method(self, CFISH_Str_Ends_With_OFFSET);
    return method(self, postfix);
}

extern CFISH_VISIBLE size_t CFISH_Str_Ends_With_Utf8_OFFSET;
static CFISH_INLINE bool
CFISH_Str_Ends_With_Utf8(cfish_String *self, const char* postfix, size_t size) {
    const CFISH_Str_Ends_With_Utf8_t method = (CFISH_Str_Ends_With_Utf8_t)cfish_obj_method(self, CFISH_Str_Ends_With_Utf8_OFFSET);
    return method(self, postfix, size);
}

extern CFISH_VISIBLE size_t CFISH_Str_Find_OFFSET;
static CFISH_INLINE int64_t
CFISH_Str_Find(cfish_String *self, cfish_String* substring) {
    const CFISH_Str_Find_t method = (CFISH_Str_Find_t)cfish_obj_method(self, CFISH_Str_Find_OFFSET);
    return method(self, substring);
}

extern CFISH_VISIBLE size_t CFISH_Str_Find_Utf8_OFFSET;
static CFISH_INLINE int64_t
CFISH_Str_Find_Utf8(cfish_String *self, const char* ptr, size_t size) {
    const CFISH_Str_Find_Utf8_t method = (CFISH_Str_Find_Utf8_t)cfish_obj_method(self, CFISH_Str_Find_Utf8_OFFSET);
    return method(self, ptr, size);
}

extern CFISH_VISIBLE size_t CFISH_Str_Equals_Utf8_OFFSET;
static CFISH_INLINE bool
CFISH_Str_Equals_Utf8(cfish_String *self, const char* ptr, size_t size) {
    const CFISH_Str_Equals_Utf8_t method = (CFISH_Str_Equals_Utf8_t)cfish_obj_method(self, CFISH_Str_Equals_Utf8_OFFSET);
    return method(self, ptr, size);
}

extern CFISH_VISIBLE size_t CFISH_Str_Length_OFFSET;
static CFISH_INLINE size_t
CFISH_Str_Length(cfish_String *self) {
    const CFISH_Str_Length_t method = (CFISH_Str_Length_t)cfish_obj_method(self, CFISH_Str_Length_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Get_Size_OFFSET;
static CFISH_INLINE size_t
CFISH_Str_Get_Size(cfish_String *self) {
    const CFISH_Str_Get_Size_t method = (CFISH_Str_Get_Size_t)cfish_obj_method(self, CFISH_Str_Get_Size_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Get_Ptr8_OFFSET;
static CFISH_INLINE const char*
CFISH_Str_Get_Ptr8(cfish_String *self) {
    const CFISH_Str_Get_Ptr8_t method = (CFISH_Str_Get_Ptr8_t)cfish_obj_method(self, CFISH_Str_Get_Ptr8_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_To_Utf8_OFFSET;
static CFISH_INLINE char*
CFISH_Str_To_Utf8(cfish_String *self) {
    const CFISH_Str_To_Utf8_t method = (CFISH_Str_To_Utf8_t)cfish_obj_method(self, CFISH_Str_To_Utf8_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Trim_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Str_Trim(cfish_String *self) {
    const CFISH_Str_Trim_t method = (CFISH_Str_Trim_t)cfish_obj_method(self, CFISH_Str_Trim_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Trim_Top_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Str_Trim_Top(cfish_String *self) {
    const CFISH_Str_Trim_Top_t method = (CFISH_Str_Trim_Top_t)cfish_obj_method(self, CFISH_Str_Trim_Top_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Trim_Tail_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Str_Trim_Tail(cfish_String *self) {
    const CFISH_Str_Trim_Tail_t method = (CFISH_Str_Trim_Tail_t)cfish_obj_method(self, CFISH_Str_Trim_Tail_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Code_Point_At_OFFSET;
static CFISH_INLINE int32_t
CFISH_Str_Code_Point_At(cfish_String *self, size_t tick) {
    const CFISH_Str_Code_Point_At_t method = (CFISH_Str_Code_Point_At_t)cfish_obj_method(self, CFISH_Str_Code_Point_At_OFFSET);
    return method(self, tick);
}

extern CFISH_VISIBLE size_t CFISH_Str_Code_Point_From_OFFSET;
static CFISH_INLINE int32_t
CFISH_Str_Code_Point_From(cfish_String *self, size_t tick) {
    const CFISH_Str_Code_Point_From_t method = (CFISH_Str_Code_Point_From_t)cfish_obj_method(self, CFISH_Str_Code_Point_From_OFFSET);
    return method(self, tick);
}

extern CFISH_VISIBLE size_t CFISH_Str_SubString_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Str_SubString(cfish_String *self, size_t offset, size_t len) {
    const CFISH_Str_SubString_t method = (CFISH_Str_SubString_t)cfish_obj_method(self, CFISH_Str_SubString_OFFSET);
    return method(self, offset, len);
}

extern CFISH_VISIBLE size_t CFISH_Str_Top_OFFSET;
static CFISH_INLINE cfish_StringIterator*
CFISH_Str_Top(cfish_String *self) {
    const CFISH_Str_Top_t method = (CFISH_Str_Top_t)cfish_obj_method(self, CFISH_Str_Top_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_Tail_OFFSET;
static CFISH_INLINE cfish_StringIterator*
CFISH_Str_Tail(cfish_String *self) {
    const CFISH_Str_Tail_t method = (CFISH_Str_Tail_t)cfish_obj_method(self, CFISH_Str_Tail_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Str_StackTop_OFFSET;
static CFISH_INLINE cfish_StackStringIterator*
CFISH_Str_StackTop(cfish_String *self, void* allocation) {
    const CFISH_Str_StackTop_t method = (CFISH_Str_StackTop_t)cfish_obj_method(self, CFISH_Str_StackTop_OFFSET);
    return method(self, allocation);
}

extern CFISH_VISIBLE size_t CFISH_Str_StackTail_OFFSET;
static CFISH_INLINE cfish_StackStringIterator*
CFISH_Str_StackTail(cfish_String *self, void* allocation) {
    const CFISH_Str_StackTail_t method = (CFISH_Str_StackTail_t)cfish_obj_method(self, CFISH_Str_StackTail_OFFSET);
    return method(self, allocation);
}



/* Declare the Class singleton for this class.
 */

extern CFISH_VISIBLE cfish_Class *CFISH_STRING;

/* Define "short names" for this class's symbols.
 */

#ifdef CFISH_USE_SHORT_NAMES
  #define String cfish_String
  #define STRING CFISH_STRING
  #define Str_new_from_utf8 cfish_Str_new_from_utf8
  #define Str_new_from_trusted_utf8 cfish_Str_new_from_trusted_utf8
  #define Str_init_from_trusted_utf8 cfish_Str_init_from_trusted_utf8
  #define Str_new_steal_utf8 cfish_Str_new_steal_utf8
  #define Str_new_steal_trusted_utf8 cfish_Str_new_steal_trusted_utf8
  #define Str_init_steal_trusted_utf8 cfish_Str_init_steal_trusted_utf8
  #define Str_new_wrap_utf8 cfish_Str_new_wrap_utf8
  #define Str_new_wrap_trusted_utf8 cfish_Str_new_wrap_trusted_utf8
  #define Str_init_wrap_trusted_utf8 cfish_Str_init_wrap_trusted_utf8
  #define Str_new_from_char cfish_Str_new_from_char
  #define Str_newf cfish_Str_newf
  #define Str_compare cfish_Str_compare
  #define Str_less_than cfish_Str_less_than
  #define Str_Inc_RefCount_IMP CFISH_Str_Inc_RefCount_IMP
  #define Str_Clone_IMP CFISH_Str_Clone_IMP
  #define Str_Destroy_IMP CFISH_Str_Destroy_IMP
  #define Str_Equals_IMP CFISH_Str_Equals_IMP
  #define Str_Compare_To_IMP CFISH_Str_Compare_To_IMP
  #define Str_Hash_Sum_IMP CFISH_Str_Hash_Sum_IMP
  #define Str_To_String_IMP CFISH_Str_To_String_IMP
  #define Str_To_I64_IMP CFISH_Str_To_I64_IMP
  #define Str_To_F64_IMP CFISH_Str_To_F64_IMP
  #define Str_Cat_IMP CFISH_Str_Cat_IMP
  #define Str_Cat_Utf8_IMP CFISH_Str_Cat_Utf8_IMP
  #define Str_Cat_Trusted_Utf8_IMP CFISH_Str_Cat_Trusted_Utf8_IMP
  #define Str_Swap_Chars_IMP CFISH_Str_Swap_Chars_IMP
  #define Str_BaseX_To_I64_IMP CFISH_Str_BaseX_To_I64_IMP
  #define Str_Starts_With_IMP CFISH_Str_Starts_With_IMP
  #define Str_Starts_With_Utf8_IMP CFISH_Str_Starts_With_Utf8_IMP
  #define Str_Ends_With_IMP CFISH_Str_Ends_With_IMP
  #define Str_Ends_With_Utf8_IMP CFISH_Str_Ends_With_Utf8_IMP
  #define Str_Find_IMP CFISH_Str_Find_IMP
  #define Str_Find_Utf8_IMP CFISH_Str_Find_Utf8_IMP
  #define Str_Equals_Utf8_IMP CFISH_Str_Equals_Utf8_IMP
  #define Str_Length_IMP CFISH_Str_Length_IMP
  #define Str_Get_Size_IMP CFISH_Str_Get_Size_IMP
  #define Str_Get_Ptr8_IMP CFISH_Str_Get_Ptr8_IMP
  #define Str_To_Utf8_IMP CFISH_Str_To_Utf8_IMP
  #define Str_Trim_IMP CFISH_Str_Trim_IMP
  #define Str_Trim_Top_IMP CFISH_Str_Trim_Top_IMP
  #define Str_Trim_Tail_IMP CFISH_Str_Trim_Tail_IMP
  #define Str_Code_Point_At_IMP CFISH_Str_Code_Point_At_IMP
  #define Str_Code_Point_From_IMP CFISH_Str_Code_Point_From_IMP
  #define Str_SubString_IMP CFISH_Str_SubString_IMP
  #define Str_Top_IMP CFISH_Str_Top_IMP
  #define Str_Tail_IMP CFISH_Str_Tail_IMP
  #define Str_StackTop_IMP CFISH_Str_StackTop_IMP
  #define Str_StackTail_IMP CFISH_Str_StackTail_IMP
  #define Str_Get_RefCount CFISH_Str_Get_RefCount
  #define Str_Get_RefCount_t CFISH_Str_Get_RefCount_t
  #define Str_Inc_RefCount CFISH_Str_Inc_RefCount
  #define Str_Inc_RefCount_t CFISH_Str_Inc_RefCount_t
  #define Str_Dec_RefCount CFISH_Str_Dec_RefCount
  #define Str_Dec_RefCount_t CFISH_Str_Dec_RefCount_t
  #define Str_To_Host CFISH_Str_To_Host
  #define Str_To_Host_t CFISH_Str_To_Host_t
  #define Str_Clone CFISH_Str_Clone
  #define Str_Clone_t CFISH_Str_Clone_t
  #define Str_Destroy CFISH_Str_Destroy
  #define Str_Destroy_t CFISH_Str_Destroy_t
  #define Str_Equals CFISH_Str_Equals
  #define Str_Equals_t CFISH_Str_Equals_t
  #define Str_Compare_To CFISH_Str_Compare_To
  #define Str_Compare_To_t CFISH_Str_Compare_To_t
  #define Str_Hash_Sum CFISH_Str_Hash_Sum
  #define Str_Hash_Sum_t CFISH_Str_Hash_Sum_t
  #define Str_Get_Class CFISH_Str_Get_Class
  #define Str_Get_Class_t CFISH_Str_Get_Class_t
  #define Str_Get_Class_Name CFISH_Str_Get_Class_Name
  #define Str_Get_Class_Name_t CFISH_Str_Get_Class_Name_t
  #define Str_Is_A CFISH_Str_Is_A
  #define Str_Is_A_t CFISH_Str_Is_A_t
  #define Str_To_String CFISH_Str_To_String
  #define Str_To_String_t CFISH_Str_To_String_t
  #define Str_To_I64 CFISH_Str_To_I64
  #define Str_To_I64_t CFISH_Str_To_I64_t
  #define Str_To_F64 CFISH_Str_To_F64
  #define Str_To_F64_t CFISH_Str_To_F64_t
  #define Str_To_Bool CFISH_Str_To_Bool
  #define Str_To_Bool_t CFISH_Str_To_Bool_t
  #define Str_Mimic CFISH_Str_Mimic
  #define Str_Mimic_t CFISH_Str_Mimic_t
  #define Str_Cat CFISH_Str_Cat
  #define Str_Cat_t CFISH_Str_Cat_t
  #define Str_Cat_Utf8 CFISH_Str_Cat_Utf8
  #define Str_Cat_Utf8_t CFISH_Str_Cat_Utf8_t
  #define Str_Cat_Trusted_Utf8 CFISH_Str_Cat_Trusted_Utf8
  #define Str_Cat_Trusted_Utf8_t CFISH_Str_Cat_Trusted_Utf8_t
  #define Str_Swap_Chars CFISH_Str_Swap_Chars
  #define Str_Swap_Chars_t CFISH_Str_Swap_Chars_t
  #define Str_BaseX_To_I64 CFISH_Str_BaseX_To_I64
  #define Str_BaseX_To_I64_t CFISH_Str_BaseX_To_I64_t
  #define Str_Starts_With CFISH_Str_Starts_With
  #define Str_Starts_With_t CFISH_Str_Starts_With_t
  #define Str_Starts_With_Utf8 CFISH_Str_Starts_With_Utf8
  #define Str_Starts_With_Utf8_t CFISH_Str_Starts_With_Utf8_t
  #define Str_Ends_With CFISH_Str_Ends_With
  #define Str_Ends_With_t CFISH_Str_Ends_With_t
  #define Str_Ends_With_Utf8 CFISH_Str_Ends_With_Utf8
  #define Str_Ends_With_Utf8_t CFISH_Str_Ends_With_Utf8_t
  #define Str_Find CFISH_Str_Find
  #define Str_Find_t CFISH_Str_Find_t
  #define Str_Find_Utf8 CFISH_Str_Find_Utf8
  #define Str_Find_Utf8_t CFISH_Str_Find_Utf8_t
  #define Str_Equals_Utf8 CFISH_Str_Equals_Utf8
  #define Str_Equals_Utf8_t CFISH_Str_Equals_Utf8_t
  #define Str_Length CFISH_Str_Length
  #define Str_Length_t CFISH_Str_Length_t
  #define Str_Get_Size CFISH_Str_Get_Size
  #define Str_Get_Size_t CFISH_Str_Get_Size_t
  #define Str_Get_Ptr8 CFISH_Str_Get_Ptr8
  #define Str_Get_Ptr8_t CFISH_Str_Get_Ptr8_t
  #define Str_To_Utf8 CFISH_Str_To_Utf8
  #define Str_To_Utf8_t CFISH_Str_To_Utf8_t
  #define Str_Trim CFISH_Str_Trim
  #define Str_Trim_t CFISH_Str_Trim_t
  #define Str_Trim_Top CFISH_Str_Trim_Top
  #define Str_Trim_Top_t CFISH_Str_Trim_Top_t
  #define Str_Trim_Tail CFISH_Str_Trim_Tail
  #define Str_Trim_Tail_t CFISH_Str_Trim_Tail_t
  #define Str_Code_Point_At CFISH_Str_Code_Point_At
  #define Str_Code_Point_At_t CFISH_Str_Code_Point_At_t
  #define Str_Code_Point_From CFISH_Str_Code_Point_From
  #define Str_Code_Point_From_t CFISH_Str_Code_Point_From_t
  #define Str_SubString CFISH_Str_SubString
  #define Str_SubString_t CFISH_Str_SubString_t
  #define Str_Top CFISH_Str_Top
  #define Str_Top_t CFISH_Str_Top_t
  #define Str_Tail CFISH_Str_Tail
  #define Str_Tail_t CFISH_Str_Tail_t
  #define Str_StackTop CFISH_Str_StackTop
  #define Str_StackTop_t CFISH_Str_StackTop_t
  #define Str_StackTail CFISH_Str_StackTail
  #define Str_StackTail_t CFISH_Str_StackTail_t
#endif /* CFISH_USE_SHORT_NAMES */



/* Include the header for this class's parent. 
 */

#include "Clownfish/String.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_CFISH_STACKSTRING
extern size_t cfish_SStr_IVARS_OFFSET;
typedef struct cfish_StackStringIVARS cfish_StackStringIVARS;
static CFISH_INLINE cfish_StackStringIVARS*
cfish_SStr_IVARS(cfish_StackString *self) {
   char *ptr = (char*)self + cfish_SStr_IVARS_OFFSET;
   return (cfish_StackStringIVARS*)ptr;
}
#ifdef CFISH_USE_SHORT_NAMES
  #define StackStringIVARS cfish_StackStringIVARS
  #define SStr_IVARS cfish_SStr_IVARS
#endif

struct cfish_StackString {
    CFISH_OBJ_HEAD
    cfish_Class* klass;
    const char* ptr;
    size_t size;
    cfish_String* origin;
};

#endif /* C_CFISH_STACKSTRING */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

CFISH_VISIBLE cfish_StackString*
cfish_SStr_new_from_str(void* allocation, size_t alloc_size, cfish_String* string);

CFISH_VISIBLE cfish_StackString*
cfish_SStr_wrap(void* allocation, cfish_String* source);

CFISH_VISIBLE cfish_StackString*
cfish_SStr_wrap_str(void* allocation, const char* ptr, size_t size);

CFISH_VISIBLE size_t
cfish_SStr_size(void);

void
CFISH_SStr_Destroy_IMP(cfish_StackString* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*CFISH_SStr_Get_RefCount_t)(cfish_StackString *self);

typedef cfish_Obj*
(*CFISH_SStr_Inc_RefCount_t)(cfish_StackString *self);

typedef uint32_t
(*CFISH_SStr_Dec_RefCount_t)(cfish_StackString *self);

typedef void*
(*CFISH_SStr_To_Host_t)(cfish_StackString *self);

typedef cfish_String*
(*CFISH_SStr_Clone_t)(cfish_StackString *self);

typedef void
(*CFISH_SStr_Destroy_t)(cfish_StackString *self);

typedef bool
(*CFISH_SStr_Equals_t)(cfish_StackString *self, cfish_Obj* other);

typedef int32_t
(*CFISH_SStr_Compare_To_t)(cfish_StackString *self, cfish_Obj* other);

typedef int32_t
(*CFISH_SStr_Hash_Sum_t)(cfish_StackString *self);

typedef cfish_Class*
(*CFISH_SStr_Get_Class_t)(cfish_StackString *self);

typedef cfish_String*
(*CFISH_SStr_Get_Class_Name_t)(cfish_StackString *self);

typedef bool
(*CFISH_SStr_Is_A_t)(cfish_StackString *self, cfish_Class* ancestor);

typedef cfish_String*
(*CFISH_SStr_To_String_t)(cfish_StackString *self);

typedef int64_t
(*CFISH_SStr_To_I64_t)(cfish_StackString *self);

typedef double
(*CFISH_SStr_To_F64_t)(cfish_StackString *self);

typedef bool
(*CFISH_SStr_To_Bool_t)(cfish_StackString *self);

typedef void
(*CFISH_SStr_Mimic_t)(cfish_StackString *self, cfish_Obj* other);

typedef cfish_String*
(*CFISH_SStr_Cat_t)(cfish_StackString *self, cfish_String* other);

typedef cfish_String*
(*CFISH_SStr_Cat_Utf8_t)(cfish_StackString *self, const char* ptr, size_t size);

typedef cfish_String*
(*CFISH_SStr_Cat_Trusted_Utf8_t)(cfish_StackString *self, const char* ptr, size_t size);

typedef cfish_String*
(*CFISH_SStr_Swap_Chars_t)(cfish_StackString *self, int32_t match, int32_t replacement);

typedef int64_t
(*CFISH_SStr_BaseX_To_I64_t)(cfish_StackString *self, uint32_t base);

typedef bool
(*CFISH_SStr_Starts_With_t)(cfish_StackString *self, cfish_String* prefix);

typedef bool
(*CFISH_SStr_Starts_With_Utf8_t)(cfish_StackString *self, const char* prefix, size_t size);

typedef bool
(*CFISH_SStr_Ends_With_t)(cfish_StackString *self, cfish_String* postfix);

typedef bool
(*CFISH_SStr_Ends_With_Utf8_t)(cfish_StackString *self, const char* postfix, size_t size);

typedef int64_t
(*CFISH_SStr_Find_t)(cfish_StackString *self, cfish_String* substring);

typedef int64_t
(*CFISH_SStr_Find_Utf8_t)(cfish_StackString *self, const char* ptr, size_t size);

typedef bool
(*CFISH_SStr_Equals_Utf8_t)(cfish_StackString *self, const char* ptr, size_t size);

typedef size_t
(*CFISH_SStr_Length_t)(cfish_StackString *self);

typedef size_t
(*CFISH_SStr_Get_Size_t)(cfish_StackString *self);

typedef const char*
(*CFISH_SStr_Get_Ptr8_t)(cfish_StackString *self);

typedef char*
(*CFISH_SStr_To_Utf8_t)(cfish_StackString *self);

typedef cfish_String*
(*CFISH_SStr_Trim_t)(cfish_StackString *self);

typedef cfish_String*
(*CFISH_SStr_Trim_Top_t)(cfish_StackString *self);

typedef cfish_String*
(*CFISH_SStr_Trim_Tail_t)(cfish_StackString *self);

typedef int32_t
(*CFISH_SStr_Code_Point_At_t)(cfish_StackString *self, size_t tick);

typedef int32_t
(*CFISH_SStr_Code_Point_From_t)(cfish_StackString *self, size_t tick);

typedef cfish_String*
(*CFISH_SStr_SubString_t)(cfish_StackString *self, size_t offset, size_t len);

typedef cfish_StringIterator*
(*CFISH_SStr_Top_t)(cfish_StackString *self);

typedef cfish_StringIterator*
(*CFISH_SStr_Tail_t)(cfish_StackString *self);

typedef cfish_StackStringIterator*
(*CFISH_SStr_StackTop_t)(cfish_StackString *self, void* allocation);

typedef cfish_StackStringIterator*
(*CFISH_SStr_StackTail_t)(cfish_StackString *self, void* allocation);



/* Define the inline functions which implement this class's virtual methods.
 */

extern CFISH_VISIBLE size_t CFISH_SStr_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_SStr_Get_RefCount(cfish_StackString *self) {
    const CFISH_SStr_Get_RefCount_t method = (CFISH_SStr_Get_RefCount_t)cfish_obj_method(self, CFISH_SStr_Get_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_SStr_Inc_RefCount(cfish_StackString *self) {
    const CFISH_SStr_Inc_RefCount_t method = (CFISH_SStr_Inc_RefCount_t)cfish_obj_method(self, CFISH_SStr_Inc_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_SStr_Dec_RefCount(cfish_StackString *self) {
    const CFISH_SStr_Dec_RefCount_t method = (CFISH_SStr_Dec_RefCount_t)cfish_obj_method(self, CFISH_SStr_Dec_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_To_Host_OFFSET;
static CFISH_INLINE void*
CFISH_SStr_To_Host(cfish_StackString *self) {
    const CFISH_SStr_To_Host_t method = (CFISH_SStr_To_Host_t)cfish_obj_method(self, CFISH_SStr_To_Host_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Clone_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_SStr_Clone(cfish_StackString *self) {
    const CFISH_SStr_Clone_t method = (CFISH_SStr_Clone_t)cfish_obj_method(self, CFISH_SStr_Clone_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Destroy_OFFSET;
static CFISH_INLINE void
CFISH_SStr_Destroy(cfish_StackString *self) {
    const CFISH_SStr_Destroy_t method = (CFISH_SStr_Destroy_t)cfish_obj_method(self, CFISH_SStr_Destroy_OFFSET);
    method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Equals_OFFSET;
static CFISH_INLINE bool
CFISH_SStr_Equals(cfish_StackString *self, cfish_Obj* other) {
    const CFISH_SStr_Equals_t method = (CFISH_SStr_Equals_t)cfish_obj_method(self, CFISH_SStr_Equals_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Compare_To_OFFSET;
static CFISH_INLINE int32_t
CFISH_SStr_Compare_To(cfish_StackString *self, cfish_Obj* other) {
    const CFISH_SStr_Compare_To_t method = (CFISH_SStr_Compare_To_t)cfish_obj_method(self, CFISH_SStr_Compare_To_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
CFISH_SStr_Hash_Sum(cfish_StackString *self) {
    const CFISH_SStr_Hash_Sum_t method = (CFISH_SStr_Hash_Sum_t)cfish_obj_method(self, CFISH_SStr_Hash_Sum_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
CFISH_SStr_Get_Class(cfish_StackString *self) {
    const CFISH_SStr_Get_Class_t method = (CFISH_SStr_Get_Class_t)cfish_obj_method(self, CFISH_SStr_Get_Class_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_SStr_Get_Class_Name(cfish_StackString *self) {
    const CFISH_SStr_Get_Class_Name_t method = (CFISH_SStr_Get_Class_Name_t)cfish_obj_method(self, CFISH_SStr_Get_Class_Name_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Is_A_OFFSET;
static CFISH_INLINE bool
CFISH_SStr_Is_A(cfish_StackString *self, cfish_Class* ancestor) {
    const CFISH_SStr_Is_A_t method = (CFISH_SStr_Is_A_t)cfish_obj_method(self, CFISH_SStr_Is_A_OFFSET);
    return method(self, ancestor);
}

extern CFISH_VISIBLE size_t CFISH_SStr_To_String_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_SStr_To_String(cfish_StackString *self) {
    const CFISH_SStr_To_String_t method = (CFISH_SStr_To_String_t)cfish_obj_method(self, CFISH_SStr_To_String_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_To_I64_OFFSET;
static CFISH_INLINE int64_t
CFISH_SStr_To_I64(cfish_StackString *self) {
    const CFISH_SStr_To_I64_t method = (CFISH_SStr_To_I64_t)cfish_obj_method(self, CFISH_SStr_To_I64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_To_F64_OFFSET;
static CFISH_INLINE double
CFISH_SStr_To_F64(cfish_StackString *self) {
    const CFISH_SStr_To_F64_t method = (CFISH_SStr_To_F64_t)cfish_obj_method(self, CFISH_SStr_To_F64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_To_Bool_OFFSET;
static CFISH_INLINE bool
CFISH_SStr_To_Bool(cfish_StackString *self) {
    const CFISH_SStr_To_Bool_t method = (CFISH_SStr_To_Bool_t)cfish_obj_method(self, CFISH_SStr_To_Bool_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Mimic_OFFSET;
static CFISH_INLINE void
CFISH_SStr_Mimic(cfish_StackString *self, cfish_Obj* other) {
    const CFISH_SStr_Mimic_t method = (CFISH_SStr_Mimic_t)cfish_obj_method(self, CFISH_SStr_Mimic_OFFSET);
    method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Cat_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_SStr_Cat(cfish_StackString *self, cfish_String* other) {
    const CFISH_SStr_Cat_t method = (CFISH_SStr_Cat_t)cfish_obj_method(self, CFISH_SStr_Cat_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Cat_Utf8_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_SStr_Cat_Utf8(cfish_StackString *self, const char* ptr, size_t size) {
    const CFISH_SStr_Cat_Utf8_t method = (CFISH_SStr_Cat_Utf8_t)cfish_obj_method(self, CFISH_SStr_Cat_Utf8_OFFSET);
    return method(self, ptr, size);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Cat_Trusted_Utf8_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_SStr_Cat_Trusted_Utf8(cfish_StackString *self, const char* ptr, size_t size) {
    const CFISH_SStr_Cat_Trusted_Utf8_t method = (CFISH_SStr_Cat_Trusted_Utf8_t)cfish_obj_method(self, CFISH_SStr_Cat_Trusted_Utf8_OFFSET);
    return method(self, ptr, size);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Swap_Chars_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_SStr_Swap_Chars(cfish_StackString *self, int32_t match, int32_t replacement) {
    const CFISH_SStr_Swap_Chars_t method = (CFISH_SStr_Swap_Chars_t)cfish_obj_method(self, CFISH_SStr_Swap_Chars_OFFSET);
    return method(self, match, replacement);
}

extern CFISH_VISIBLE size_t CFISH_SStr_BaseX_To_I64_OFFSET;
static CFISH_INLINE int64_t
CFISH_SStr_BaseX_To_I64(cfish_StackString *self, uint32_t base) {
    const CFISH_SStr_BaseX_To_I64_t method = (CFISH_SStr_BaseX_To_I64_t)cfish_obj_method(self, CFISH_SStr_BaseX_To_I64_OFFSET);
    return method(self, base);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Starts_With_OFFSET;
static CFISH_INLINE bool
CFISH_SStr_Starts_With(cfish_StackString *self, cfish_String* prefix) {
    const CFISH_SStr_Starts_With_t method = (CFISH_SStr_Starts_With_t)cfish_obj_method(self, CFISH_SStr_Starts_With_OFFSET);
    return method(self, prefix);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Starts_With_Utf8_OFFSET;
static CFISH_INLINE bool
CFISH_SStr_Starts_With_Utf8(cfish_StackString *self, const char* prefix, size_t size) {
    const CFISH_SStr_Starts_With_Utf8_t method = (CFISH_SStr_Starts_With_Utf8_t)cfish_obj_method(self, CFISH_SStr_Starts_With_Utf8_OFFSET);
    return method(self, prefix, size);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Ends_With_OFFSET;
static CFISH_INLINE bool
CFISH_SStr_Ends_With(cfish_StackString *self, cfish_String* postfix) {
    const CFISH_SStr_Ends_With_t method = (CFISH_SStr_Ends_With_t)cfish_obj_method(self, CFISH_SStr_Ends_With_OFFSET);
    return method(self, postfix);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Ends_With_Utf8_OFFSET;
static CFISH_INLINE bool
CFISH_SStr_Ends_With_Utf8(cfish_StackString *self, const char* postfix, size_t size) {
    const CFISH_SStr_Ends_With_Utf8_t method = (CFISH_SStr_Ends_With_Utf8_t)cfish_obj_method(self, CFISH_SStr_Ends_With_Utf8_OFFSET);
    return method(self, postfix, size);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Find_OFFSET;
static CFISH_INLINE int64_t
CFISH_SStr_Find(cfish_StackString *self, cfish_String* substring) {
    const CFISH_SStr_Find_t method = (CFISH_SStr_Find_t)cfish_obj_method(self, CFISH_SStr_Find_OFFSET);
    return method(self, substring);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Find_Utf8_OFFSET;
static CFISH_INLINE int64_t
CFISH_SStr_Find_Utf8(cfish_StackString *self, const char* ptr, size_t size) {
    const CFISH_SStr_Find_Utf8_t method = (CFISH_SStr_Find_Utf8_t)cfish_obj_method(self, CFISH_SStr_Find_Utf8_OFFSET);
    return method(self, ptr, size);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Equals_Utf8_OFFSET;
static CFISH_INLINE bool
CFISH_SStr_Equals_Utf8(cfish_StackString *self, const char* ptr, size_t size) {
    const CFISH_SStr_Equals_Utf8_t method = (CFISH_SStr_Equals_Utf8_t)cfish_obj_method(self, CFISH_SStr_Equals_Utf8_OFFSET);
    return method(self, ptr, size);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Length_OFFSET;
static CFISH_INLINE size_t
CFISH_SStr_Length(cfish_StackString *self) {
    const CFISH_SStr_Length_t method = (CFISH_SStr_Length_t)cfish_obj_method(self, CFISH_SStr_Length_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Get_Size_OFFSET;
static CFISH_INLINE size_t
CFISH_SStr_Get_Size(cfish_StackString *self) {
    const CFISH_SStr_Get_Size_t method = (CFISH_SStr_Get_Size_t)cfish_obj_method(self, CFISH_SStr_Get_Size_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Get_Ptr8_OFFSET;
static CFISH_INLINE const char*
CFISH_SStr_Get_Ptr8(cfish_StackString *self) {
    const CFISH_SStr_Get_Ptr8_t method = (CFISH_SStr_Get_Ptr8_t)cfish_obj_method(self, CFISH_SStr_Get_Ptr8_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_To_Utf8_OFFSET;
static CFISH_INLINE char*
CFISH_SStr_To_Utf8(cfish_StackString *self) {
    const CFISH_SStr_To_Utf8_t method = (CFISH_SStr_To_Utf8_t)cfish_obj_method(self, CFISH_SStr_To_Utf8_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Trim_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_SStr_Trim(cfish_StackString *self) {
    const CFISH_SStr_Trim_t method = (CFISH_SStr_Trim_t)cfish_obj_method(self, CFISH_SStr_Trim_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Trim_Top_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_SStr_Trim_Top(cfish_StackString *self) {
    const CFISH_SStr_Trim_Top_t method = (CFISH_SStr_Trim_Top_t)cfish_obj_method(self, CFISH_SStr_Trim_Top_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Trim_Tail_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_SStr_Trim_Tail(cfish_StackString *self) {
    const CFISH_SStr_Trim_Tail_t method = (CFISH_SStr_Trim_Tail_t)cfish_obj_method(self, CFISH_SStr_Trim_Tail_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Code_Point_At_OFFSET;
static CFISH_INLINE int32_t
CFISH_SStr_Code_Point_At(cfish_StackString *self, size_t tick) {
    const CFISH_SStr_Code_Point_At_t method = (CFISH_SStr_Code_Point_At_t)cfish_obj_method(self, CFISH_SStr_Code_Point_At_OFFSET);
    return method(self, tick);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Code_Point_From_OFFSET;
static CFISH_INLINE int32_t
CFISH_SStr_Code_Point_From(cfish_StackString *self, size_t tick) {
    const CFISH_SStr_Code_Point_From_t method = (CFISH_SStr_Code_Point_From_t)cfish_obj_method(self, CFISH_SStr_Code_Point_From_OFFSET);
    return method(self, tick);
}

extern CFISH_VISIBLE size_t CFISH_SStr_SubString_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_SStr_SubString(cfish_StackString *self, size_t offset, size_t len) {
    const CFISH_SStr_SubString_t method = (CFISH_SStr_SubString_t)cfish_obj_method(self, CFISH_SStr_SubString_OFFSET);
    return method(self, offset, len);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Top_OFFSET;
static CFISH_INLINE cfish_StringIterator*
CFISH_SStr_Top(cfish_StackString *self) {
    const CFISH_SStr_Top_t method = (CFISH_SStr_Top_t)cfish_obj_method(self, CFISH_SStr_Top_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_Tail_OFFSET;
static CFISH_INLINE cfish_StringIterator*
CFISH_SStr_Tail(cfish_StackString *self) {
    const CFISH_SStr_Tail_t method = (CFISH_SStr_Tail_t)cfish_obj_method(self, CFISH_SStr_Tail_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStr_StackTop_OFFSET;
static CFISH_INLINE cfish_StackStringIterator*
CFISH_SStr_StackTop(cfish_StackString *self, void* allocation) {
    const CFISH_SStr_StackTop_t method = (CFISH_SStr_StackTop_t)cfish_obj_method(self, CFISH_SStr_StackTop_OFFSET);
    return method(self, allocation);
}

extern CFISH_VISIBLE size_t CFISH_SStr_StackTail_OFFSET;
static CFISH_INLINE cfish_StackStringIterator*
CFISH_SStr_StackTail(cfish_StackString *self, void* allocation) {
    const CFISH_SStr_StackTail_t method = (CFISH_SStr_StackTail_t)cfish_obj_method(self, CFISH_SStr_StackTail_OFFSET);
    return method(self, allocation);
}



/* Declare the Class singleton for this class.
 */

extern CFISH_VISIBLE cfish_Class *CFISH_STACKSTRING;

/* Define "short names" for this class's symbols.
 */

#ifdef CFISH_USE_SHORT_NAMES
  #define StackString cfish_StackString
  #define STACKSTRING CFISH_STACKSTRING
  #define SStr_new_from_str cfish_SStr_new_from_str
  #define SStr_wrap cfish_SStr_wrap
  #define SStr_wrap_str cfish_SStr_wrap_str
  #define SStr_size cfish_SStr_size
  #define SStr_Destroy_IMP CFISH_SStr_Destroy_IMP
  #define SStr_Get_RefCount CFISH_SStr_Get_RefCount
  #define SStr_Get_RefCount_t CFISH_SStr_Get_RefCount_t
  #define SStr_Inc_RefCount CFISH_SStr_Inc_RefCount
  #define SStr_Inc_RefCount_t CFISH_SStr_Inc_RefCount_t
  #define SStr_Dec_RefCount CFISH_SStr_Dec_RefCount
  #define SStr_Dec_RefCount_t CFISH_SStr_Dec_RefCount_t
  #define SStr_To_Host CFISH_SStr_To_Host
  #define SStr_To_Host_t CFISH_SStr_To_Host_t
  #define SStr_Clone CFISH_SStr_Clone
  #define SStr_Clone_t CFISH_SStr_Clone_t
  #define SStr_Destroy CFISH_SStr_Destroy
  #define SStr_Destroy_t CFISH_SStr_Destroy_t
  #define SStr_Equals CFISH_SStr_Equals
  #define SStr_Equals_t CFISH_SStr_Equals_t
  #define SStr_Compare_To CFISH_SStr_Compare_To
  #define SStr_Compare_To_t CFISH_SStr_Compare_To_t
  #define SStr_Hash_Sum CFISH_SStr_Hash_Sum
  #define SStr_Hash_Sum_t CFISH_SStr_Hash_Sum_t
  #define SStr_Get_Class CFISH_SStr_Get_Class
  #define SStr_Get_Class_t CFISH_SStr_Get_Class_t
  #define SStr_Get_Class_Name CFISH_SStr_Get_Class_Name
  #define SStr_Get_Class_Name_t CFISH_SStr_Get_Class_Name_t
  #define SStr_Is_A CFISH_SStr_Is_A
  #define SStr_Is_A_t CFISH_SStr_Is_A_t
  #define SStr_To_String CFISH_SStr_To_String
  #define SStr_To_String_t CFISH_SStr_To_String_t
  #define SStr_To_I64 CFISH_SStr_To_I64
  #define SStr_To_I64_t CFISH_SStr_To_I64_t
  #define SStr_To_F64 CFISH_SStr_To_F64
  #define SStr_To_F64_t CFISH_SStr_To_F64_t
  #define SStr_To_Bool CFISH_SStr_To_Bool
  #define SStr_To_Bool_t CFISH_SStr_To_Bool_t
  #define SStr_Mimic CFISH_SStr_Mimic
  #define SStr_Mimic_t CFISH_SStr_Mimic_t
  #define SStr_Cat CFISH_SStr_Cat
  #define SStr_Cat_t CFISH_SStr_Cat_t
  #define SStr_Cat_Utf8 CFISH_SStr_Cat_Utf8
  #define SStr_Cat_Utf8_t CFISH_SStr_Cat_Utf8_t
  #define SStr_Cat_Trusted_Utf8 CFISH_SStr_Cat_Trusted_Utf8
  #define SStr_Cat_Trusted_Utf8_t CFISH_SStr_Cat_Trusted_Utf8_t
  #define SStr_Swap_Chars CFISH_SStr_Swap_Chars
  #define SStr_Swap_Chars_t CFISH_SStr_Swap_Chars_t
  #define SStr_BaseX_To_I64 CFISH_SStr_BaseX_To_I64
  #define SStr_BaseX_To_I64_t CFISH_SStr_BaseX_To_I64_t
  #define SStr_Starts_With CFISH_SStr_Starts_With
  #define SStr_Starts_With_t CFISH_SStr_Starts_With_t
  #define SStr_Starts_With_Utf8 CFISH_SStr_Starts_With_Utf8
  #define SStr_Starts_With_Utf8_t CFISH_SStr_Starts_With_Utf8_t
  #define SStr_Ends_With CFISH_SStr_Ends_With
  #define SStr_Ends_With_t CFISH_SStr_Ends_With_t
  #define SStr_Ends_With_Utf8 CFISH_SStr_Ends_With_Utf8
  #define SStr_Ends_With_Utf8_t CFISH_SStr_Ends_With_Utf8_t
  #define SStr_Find CFISH_SStr_Find
  #define SStr_Find_t CFISH_SStr_Find_t
  #define SStr_Find_Utf8 CFISH_SStr_Find_Utf8
  #define SStr_Find_Utf8_t CFISH_SStr_Find_Utf8_t
  #define SStr_Equals_Utf8 CFISH_SStr_Equals_Utf8
  #define SStr_Equals_Utf8_t CFISH_SStr_Equals_Utf8_t
  #define SStr_Length CFISH_SStr_Length
  #define SStr_Length_t CFISH_SStr_Length_t
  #define SStr_Get_Size CFISH_SStr_Get_Size
  #define SStr_Get_Size_t CFISH_SStr_Get_Size_t
  #define SStr_Get_Ptr8 CFISH_SStr_Get_Ptr8
  #define SStr_Get_Ptr8_t CFISH_SStr_Get_Ptr8_t
  #define SStr_To_Utf8 CFISH_SStr_To_Utf8
  #define SStr_To_Utf8_t CFISH_SStr_To_Utf8_t
  #define SStr_Trim CFISH_SStr_Trim
  #define SStr_Trim_t CFISH_SStr_Trim_t
  #define SStr_Trim_Top CFISH_SStr_Trim_Top
  #define SStr_Trim_Top_t CFISH_SStr_Trim_Top_t
  #define SStr_Trim_Tail CFISH_SStr_Trim_Tail
  #define SStr_Trim_Tail_t CFISH_SStr_Trim_Tail_t
  #define SStr_Code_Point_At CFISH_SStr_Code_Point_At
  #define SStr_Code_Point_At_t CFISH_SStr_Code_Point_At_t
  #define SStr_Code_Point_From CFISH_SStr_Code_Point_From
  #define SStr_Code_Point_From_t CFISH_SStr_Code_Point_From_t
  #define SStr_SubString CFISH_SStr_SubString
  #define SStr_SubString_t CFISH_SStr_SubString_t
  #define SStr_Top CFISH_SStr_Top
  #define SStr_Top_t CFISH_SStr_Top_t
  #define SStr_Tail CFISH_SStr_Tail
  #define SStr_Tail_t CFISH_SStr_Tail_t
  #define SStr_StackTop CFISH_SStr_StackTop
  #define SStr_StackTop_t CFISH_SStr_StackTop_t
  #define SStr_StackTail CFISH_SStr_StackTail
  #define SStr_StackTail_t CFISH_SStr_StackTail_t
#endif /* CFISH_USE_SHORT_NAMES */



/* Include the header for this class's parent. 
 */

#include "Clownfish/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_CFISH_STRINGITERATOR
extern size_t cfish_StrIter_IVARS_OFFSET;
typedef struct cfish_StringIteratorIVARS cfish_StringIteratorIVARS;
static CFISH_INLINE cfish_StringIteratorIVARS*
cfish_StrIter_IVARS(cfish_StringIterator *self) {
   char *ptr = (char*)self + cfish_StrIter_IVARS_OFFSET;
   return (cfish_StringIteratorIVARS*)ptr;
}
#ifdef CFISH_USE_SHORT_NAMES
  #define StringIteratorIVARS cfish_StringIteratorIVARS
  #define StrIter_IVARS cfish_StrIter_IVARS
#endif

struct cfish_StringIterator {
    CFISH_OBJ_HEAD
    cfish_Class* klass;
    cfish_String* string;
    size_t byte_offset;
};

#endif /* C_CFISH_STRINGITERATOR */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

CFISH_VISIBLE cfish_StringIterator*
cfish_StrIter_new(cfish_String* string, size_t byte_offset);

CFISH_VISIBLE cfish_String*
cfish_StrIter_substring(cfish_StringIterator* top, cfish_StringIterator* tail);

cfish_StringIterator*
CFISH_StrIter_Clone_IMP(cfish_StringIterator* self);

void
CFISH_StrIter_Destroy_IMP(cfish_StringIterator* self);

bool
CFISH_StrIter_Equals_IMP(cfish_StringIterator* self, cfish_Obj* other);

int32_t
CFISH_StrIter_Compare_To_IMP(cfish_StringIterator* self, cfish_Obj* other);

void
CFISH_StrIter_Assign_IMP(cfish_StringIterator* self, cfish_StringIterator* other);

bool
CFISH_StrIter_Has_Next_IMP(cfish_StringIterator* self);

bool
CFISH_StrIter_Has_Prev_IMP(cfish_StringIterator* self);

int32_t
CFISH_StrIter_Next_IMP(cfish_StringIterator* self);

int32_t
CFISH_StrIter_Prev_IMP(cfish_StringIterator* self);

size_t
CFISH_StrIter_Advance_IMP(cfish_StringIterator* self, size_t num);

size_t
CFISH_StrIter_Recede_IMP(cfish_StringIterator* self, size_t num);

size_t
CFISH_StrIter_Skip_Next_Whitespace_IMP(cfish_StringIterator* self);

size_t
CFISH_StrIter_Skip_Prev_Whitespace_IMP(cfish_StringIterator* self);

bool
CFISH_StrIter_Starts_With_IMP(cfish_StringIterator* self, cfish_String* prefix);

bool
CFISH_StrIter_Starts_With_Utf8_IMP(cfish_StringIterator* self, const char* prefix, size_t size);

bool
CFISH_StrIter_Ends_With_IMP(cfish_StringIterator* self, cfish_String* postfix);

bool
CFISH_StrIter_Ends_With_Utf8_IMP(cfish_StringIterator* self, const char* postfix, size_t size);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*CFISH_StrIter_Get_RefCount_t)(cfish_StringIterator *self);

typedef cfish_Obj*
(*CFISH_StrIter_Inc_RefCount_t)(cfish_StringIterator *self);

typedef uint32_t
(*CFISH_StrIter_Dec_RefCount_t)(cfish_StringIterator *self);

typedef void*
(*CFISH_StrIter_To_Host_t)(cfish_StringIterator *self);

typedef cfish_StringIterator*
(*CFISH_StrIter_Clone_t)(cfish_StringIterator *self);

typedef void
(*CFISH_StrIter_Destroy_t)(cfish_StringIterator *self);

typedef bool
(*CFISH_StrIter_Equals_t)(cfish_StringIterator *self, cfish_Obj* other);

typedef int32_t
(*CFISH_StrIter_Compare_To_t)(cfish_StringIterator *self, cfish_Obj* other);

typedef int32_t
(*CFISH_StrIter_Hash_Sum_t)(cfish_StringIterator *self);

typedef cfish_Class*
(*CFISH_StrIter_Get_Class_t)(cfish_StringIterator *self);

typedef cfish_String*
(*CFISH_StrIter_Get_Class_Name_t)(cfish_StringIterator *self);

typedef bool
(*CFISH_StrIter_Is_A_t)(cfish_StringIterator *self, cfish_Class* ancestor);

typedef cfish_String*
(*CFISH_StrIter_To_String_t)(cfish_StringIterator *self);

typedef int64_t
(*CFISH_StrIter_To_I64_t)(cfish_StringIterator *self);

typedef double
(*CFISH_StrIter_To_F64_t)(cfish_StringIterator *self);

typedef bool
(*CFISH_StrIter_To_Bool_t)(cfish_StringIterator *self);

typedef void
(*CFISH_StrIter_Mimic_t)(cfish_StringIterator *self, cfish_Obj* other);

typedef void
(*CFISH_StrIter_Assign_t)(cfish_StringIterator *self, cfish_StringIterator* other);

typedef bool
(*CFISH_StrIter_Has_Next_t)(cfish_StringIterator *self);

typedef bool
(*CFISH_StrIter_Has_Prev_t)(cfish_StringIterator *self);

typedef int32_t
(*CFISH_StrIter_Next_t)(cfish_StringIterator *self);

typedef int32_t
(*CFISH_StrIter_Prev_t)(cfish_StringIterator *self);

typedef size_t
(*CFISH_StrIter_Advance_t)(cfish_StringIterator *self, size_t num);

typedef size_t
(*CFISH_StrIter_Recede_t)(cfish_StringIterator *self, size_t num);

typedef size_t
(*CFISH_StrIter_Skip_Next_Whitespace_t)(cfish_StringIterator *self);

typedef size_t
(*CFISH_StrIter_Skip_Prev_Whitespace_t)(cfish_StringIterator *self);

typedef bool
(*CFISH_StrIter_Starts_With_t)(cfish_StringIterator *self, cfish_String* prefix);

typedef bool
(*CFISH_StrIter_Starts_With_Utf8_t)(cfish_StringIterator *self, const char* prefix, size_t size);

typedef bool
(*CFISH_StrIter_Ends_With_t)(cfish_StringIterator *self, cfish_String* postfix);

typedef bool
(*CFISH_StrIter_Ends_With_Utf8_t)(cfish_StringIterator *self, const char* postfix, size_t size);



/* Define the inline functions which implement this class's virtual methods.
 */

extern CFISH_VISIBLE size_t CFISH_StrIter_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_StrIter_Get_RefCount(cfish_StringIterator *self) {
    const CFISH_StrIter_Get_RefCount_t method = (CFISH_StrIter_Get_RefCount_t)cfish_obj_method(self, CFISH_StrIter_Get_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_StrIter_Inc_RefCount(cfish_StringIterator *self) {
    const CFISH_StrIter_Inc_RefCount_t method = (CFISH_StrIter_Inc_RefCount_t)cfish_obj_method(self, CFISH_StrIter_Inc_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_StrIter_Dec_RefCount(cfish_StringIterator *self) {
    const CFISH_StrIter_Dec_RefCount_t method = (CFISH_StrIter_Dec_RefCount_t)cfish_obj_method(self, CFISH_StrIter_Dec_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_To_Host_OFFSET;
static CFISH_INLINE void*
CFISH_StrIter_To_Host(cfish_StringIterator *self) {
    const CFISH_StrIter_To_Host_t method = (CFISH_StrIter_To_Host_t)cfish_obj_method(self, CFISH_StrIter_To_Host_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Clone_OFFSET;
static CFISH_INLINE cfish_StringIterator*
CFISH_StrIter_Clone(cfish_StringIterator *self) {
    const CFISH_StrIter_Clone_t method = (CFISH_StrIter_Clone_t)cfish_obj_method(self, CFISH_StrIter_Clone_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Destroy_OFFSET;
static CFISH_INLINE void
CFISH_StrIter_Destroy(cfish_StringIterator *self) {
    const CFISH_StrIter_Destroy_t method = (CFISH_StrIter_Destroy_t)cfish_obj_method(self, CFISH_StrIter_Destroy_OFFSET);
    method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Equals_OFFSET;
static CFISH_INLINE bool
CFISH_StrIter_Equals(cfish_StringIterator *self, cfish_Obj* other) {
    const CFISH_StrIter_Equals_t method = (CFISH_StrIter_Equals_t)cfish_obj_method(self, CFISH_StrIter_Equals_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Compare_To_OFFSET;
static CFISH_INLINE int32_t
CFISH_StrIter_Compare_To(cfish_StringIterator *self, cfish_Obj* other) {
    const CFISH_StrIter_Compare_To_t method = (CFISH_StrIter_Compare_To_t)cfish_obj_method(self, CFISH_StrIter_Compare_To_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
CFISH_StrIter_Hash_Sum(cfish_StringIterator *self) {
    const CFISH_StrIter_Hash_Sum_t method = (CFISH_StrIter_Hash_Sum_t)cfish_obj_method(self, CFISH_StrIter_Hash_Sum_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
CFISH_StrIter_Get_Class(cfish_StringIterator *self) {
    const CFISH_StrIter_Get_Class_t method = (CFISH_StrIter_Get_Class_t)cfish_obj_method(self, CFISH_StrIter_Get_Class_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_StrIter_Get_Class_Name(cfish_StringIterator *self) {
    const CFISH_StrIter_Get_Class_Name_t method = (CFISH_StrIter_Get_Class_Name_t)cfish_obj_method(self, CFISH_StrIter_Get_Class_Name_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Is_A_OFFSET;
static CFISH_INLINE bool
CFISH_StrIter_Is_A(cfish_StringIterator *self, cfish_Class* ancestor) {
    const CFISH_StrIter_Is_A_t method = (CFISH_StrIter_Is_A_t)cfish_obj_method(self, CFISH_StrIter_Is_A_OFFSET);
    return method(self, ancestor);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_To_String_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_StrIter_To_String(cfish_StringIterator *self) {
    const CFISH_StrIter_To_String_t method = (CFISH_StrIter_To_String_t)cfish_obj_method(self, CFISH_StrIter_To_String_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_To_I64_OFFSET;
static CFISH_INLINE int64_t
CFISH_StrIter_To_I64(cfish_StringIterator *self) {
    const CFISH_StrIter_To_I64_t method = (CFISH_StrIter_To_I64_t)cfish_obj_method(self, CFISH_StrIter_To_I64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_To_F64_OFFSET;
static CFISH_INLINE double
CFISH_StrIter_To_F64(cfish_StringIterator *self) {
    const CFISH_StrIter_To_F64_t method = (CFISH_StrIter_To_F64_t)cfish_obj_method(self, CFISH_StrIter_To_F64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_To_Bool_OFFSET;
static CFISH_INLINE bool
CFISH_StrIter_To_Bool(cfish_StringIterator *self) {
    const CFISH_StrIter_To_Bool_t method = (CFISH_StrIter_To_Bool_t)cfish_obj_method(self, CFISH_StrIter_To_Bool_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Mimic_OFFSET;
static CFISH_INLINE void
CFISH_StrIter_Mimic(cfish_StringIterator *self, cfish_Obj* other) {
    const CFISH_StrIter_Mimic_t method = (CFISH_StrIter_Mimic_t)cfish_obj_method(self, CFISH_StrIter_Mimic_OFFSET);
    method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Assign_OFFSET;
static CFISH_INLINE void
CFISH_StrIter_Assign(cfish_StringIterator *self, cfish_StringIterator* other) {
    const CFISH_StrIter_Assign_t method = (CFISH_StrIter_Assign_t)cfish_obj_method(self, CFISH_StrIter_Assign_OFFSET);
    method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Has_Next_OFFSET;
static CFISH_INLINE bool
CFISH_StrIter_Has_Next(cfish_StringIterator *self) {
    const CFISH_StrIter_Has_Next_t method = (CFISH_StrIter_Has_Next_t)cfish_obj_method(self, CFISH_StrIter_Has_Next_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Has_Prev_OFFSET;
static CFISH_INLINE bool
CFISH_StrIter_Has_Prev(cfish_StringIterator *self) {
    const CFISH_StrIter_Has_Prev_t method = (CFISH_StrIter_Has_Prev_t)cfish_obj_method(self, CFISH_StrIter_Has_Prev_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Next_OFFSET;
static CFISH_INLINE int32_t
CFISH_StrIter_Next(cfish_StringIterator *self) {
    const CFISH_StrIter_Next_t method = (CFISH_StrIter_Next_t)cfish_obj_method(self, CFISH_StrIter_Next_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Prev_OFFSET;
static CFISH_INLINE int32_t
CFISH_StrIter_Prev(cfish_StringIterator *self) {
    const CFISH_StrIter_Prev_t method = (CFISH_StrIter_Prev_t)cfish_obj_method(self, CFISH_StrIter_Prev_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Advance_OFFSET;
static CFISH_INLINE size_t
CFISH_StrIter_Advance(cfish_StringIterator *self, size_t num) {
    const CFISH_StrIter_Advance_t method = (CFISH_StrIter_Advance_t)cfish_obj_method(self, CFISH_StrIter_Advance_OFFSET);
    return method(self, num);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Recede_OFFSET;
static CFISH_INLINE size_t
CFISH_StrIter_Recede(cfish_StringIterator *self, size_t num) {
    const CFISH_StrIter_Recede_t method = (CFISH_StrIter_Recede_t)cfish_obj_method(self, CFISH_StrIter_Recede_OFFSET);
    return method(self, num);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Skip_Next_Whitespace_OFFSET;
static CFISH_INLINE size_t
CFISH_StrIter_Skip_Next_Whitespace(cfish_StringIterator *self) {
    const CFISH_StrIter_Skip_Next_Whitespace_t method = (CFISH_StrIter_Skip_Next_Whitespace_t)cfish_obj_method(self, CFISH_StrIter_Skip_Next_Whitespace_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Skip_Prev_Whitespace_OFFSET;
static CFISH_INLINE size_t
CFISH_StrIter_Skip_Prev_Whitespace(cfish_StringIterator *self) {
    const CFISH_StrIter_Skip_Prev_Whitespace_t method = (CFISH_StrIter_Skip_Prev_Whitespace_t)cfish_obj_method(self, CFISH_StrIter_Skip_Prev_Whitespace_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Starts_With_OFFSET;
static CFISH_INLINE bool
CFISH_StrIter_Starts_With(cfish_StringIterator *self, cfish_String* prefix) {
    const CFISH_StrIter_Starts_With_t method = (CFISH_StrIter_Starts_With_t)cfish_obj_method(self, CFISH_StrIter_Starts_With_OFFSET);
    return method(self, prefix);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Starts_With_Utf8_OFFSET;
static CFISH_INLINE bool
CFISH_StrIter_Starts_With_Utf8(cfish_StringIterator *self, const char* prefix, size_t size) {
    const CFISH_StrIter_Starts_With_Utf8_t method = (CFISH_StrIter_Starts_With_Utf8_t)cfish_obj_method(self, CFISH_StrIter_Starts_With_Utf8_OFFSET);
    return method(self, prefix, size);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Ends_With_OFFSET;
static CFISH_INLINE bool
CFISH_StrIter_Ends_With(cfish_StringIterator *self, cfish_String* postfix) {
    const CFISH_StrIter_Ends_With_t method = (CFISH_StrIter_Ends_With_t)cfish_obj_method(self, CFISH_StrIter_Ends_With_OFFSET);
    return method(self, postfix);
}

extern CFISH_VISIBLE size_t CFISH_StrIter_Ends_With_Utf8_OFFSET;
static CFISH_INLINE bool
CFISH_StrIter_Ends_With_Utf8(cfish_StringIterator *self, const char* postfix, size_t size) {
    const CFISH_StrIter_Ends_With_Utf8_t method = (CFISH_StrIter_Ends_With_Utf8_t)cfish_obj_method(self, CFISH_StrIter_Ends_With_Utf8_OFFSET);
    return method(self, postfix, size);
}



/* Declare the Class singleton for this class.
 */

extern CFISH_VISIBLE cfish_Class *CFISH_STRINGITERATOR;

/* Define "short names" for this class's symbols.
 */

#ifdef CFISH_USE_SHORT_NAMES
  #define StringIterator cfish_StringIterator
  #define STRINGITERATOR CFISH_STRINGITERATOR
  #define StrIter_new cfish_StrIter_new
  #define StrIter_substring cfish_StrIter_substring
  #define StrIter_Clone_IMP CFISH_StrIter_Clone_IMP
  #define StrIter_Destroy_IMP CFISH_StrIter_Destroy_IMP
  #define StrIter_Equals_IMP CFISH_StrIter_Equals_IMP
  #define StrIter_Compare_To_IMP CFISH_StrIter_Compare_To_IMP
  #define StrIter_Assign_IMP CFISH_StrIter_Assign_IMP
  #define StrIter_Has_Next_IMP CFISH_StrIter_Has_Next_IMP
  #define StrIter_Has_Prev_IMP CFISH_StrIter_Has_Prev_IMP
  #define StrIter_Next_IMP CFISH_StrIter_Next_IMP
  #define StrIter_Prev_IMP CFISH_StrIter_Prev_IMP
  #define StrIter_Advance_IMP CFISH_StrIter_Advance_IMP
  #define StrIter_Recede_IMP CFISH_StrIter_Recede_IMP
  #define StrIter_Skip_Next_Whitespace_IMP CFISH_StrIter_Skip_Next_Whitespace_IMP
  #define StrIter_Skip_Prev_Whitespace_IMP CFISH_StrIter_Skip_Prev_Whitespace_IMP
  #define StrIter_Starts_With_IMP CFISH_StrIter_Starts_With_IMP
  #define StrIter_Starts_With_Utf8_IMP CFISH_StrIter_Starts_With_Utf8_IMP
  #define StrIter_Ends_With_IMP CFISH_StrIter_Ends_With_IMP
  #define StrIter_Ends_With_Utf8_IMP CFISH_StrIter_Ends_With_Utf8_IMP
  #define StrIter_Get_RefCount CFISH_StrIter_Get_RefCount
  #define StrIter_Get_RefCount_t CFISH_StrIter_Get_RefCount_t
  #define StrIter_Inc_RefCount CFISH_StrIter_Inc_RefCount
  #define StrIter_Inc_RefCount_t CFISH_StrIter_Inc_RefCount_t
  #define StrIter_Dec_RefCount CFISH_StrIter_Dec_RefCount
  #define StrIter_Dec_RefCount_t CFISH_StrIter_Dec_RefCount_t
  #define StrIter_To_Host CFISH_StrIter_To_Host
  #define StrIter_To_Host_t CFISH_StrIter_To_Host_t
  #define StrIter_Clone CFISH_StrIter_Clone
  #define StrIter_Clone_t CFISH_StrIter_Clone_t
  #define StrIter_Destroy CFISH_StrIter_Destroy
  #define StrIter_Destroy_t CFISH_StrIter_Destroy_t
  #define StrIter_Equals CFISH_StrIter_Equals
  #define StrIter_Equals_t CFISH_StrIter_Equals_t
  #define StrIter_Compare_To CFISH_StrIter_Compare_To
  #define StrIter_Compare_To_t CFISH_StrIter_Compare_To_t
  #define StrIter_Hash_Sum CFISH_StrIter_Hash_Sum
  #define StrIter_Hash_Sum_t CFISH_StrIter_Hash_Sum_t
  #define StrIter_Get_Class CFISH_StrIter_Get_Class
  #define StrIter_Get_Class_t CFISH_StrIter_Get_Class_t
  #define StrIter_Get_Class_Name CFISH_StrIter_Get_Class_Name
  #define StrIter_Get_Class_Name_t CFISH_StrIter_Get_Class_Name_t
  #define StrIter_Is_A CFISH_StrIter_Is_A
  #define StrIter_Is_A_t CFISH_StrIter_Is_A_t
  #define StrIter_To_String CFISH_StrIter_To_String
  #define StrIter_To_String_t CFISH_StrIter_To_String_t
  #define StrIter_To_I64 CFISH_StrIter_To_I64
  #define StrIter_To_I64_t CFISH_StrIter_To_I64_t
  #define StrIter_To_F64 CFISH_StrIter_To_F64
  #define StrIter_To_F64_t CFISH_StrIter_To_F64_t
  #define StrIter_To_Bool CFISH_StrIter_To_Bool
  #define StrIter_To_Bool_t CFISH_StrIter_To_Bool_t
  #define StrIter_Mimic CFISH_StrIter_Mimic
  #define StrIter_Mimic_t CFISH_StrIter_Mimic_t
  #define StrIter_Assign CFISH_StrIter_Assign
  #define StrIter_Assign_t CFISH_StrIter_Assign_t
  #define StrIter_Has_Next CFISH_StrIter_Has_Next
  #define StrIter_Has_Next_t CFISH_StrIter_Has_Next_t
  #define StrIter_Has_Prev CFISH_StrIter_Has_Prev
  #define StrIter_Has_Prev_t CFISH_StrIter_Has_Prev_t
  #define StrIter_Next CFISH_StrIter_Next
  #define StrIter_Next_t CFISH_StrIter_Next_t
  #define StrIter_Prev CFISH_StrIter_Prev
  #define StrIter_Prev_t CFISH_StrIter_Prev_t
  #define StrIter_Advance CFISH_StrIter_Advance
  #define StrIter_Advance_t CFISH_StrIter_Advance_t
  #define StrIter_Recede CFISH_StrIter_Recede
  #define StrIter_Recede_t CFISH_StrIter_Recede_t
  #define StrIter_Skip_Next_Whitespace CFISH_StrIter_Skip_Next_Whitespace
  #define StrIter_Skip_Next_Whitespace_t CFISH_StrIter_Skip_Next_Whitespace_t
  #define StrIter_Skip_Prev_Whitespace CFISH_StrIter_Skip_Prev_Whitespace
  #define StrIter_Skip_Prev_Whitespace_t CFISH_StrIter_Skip_Prev_Whitespace_t
  #define StrIter_Starts_With CFISH_StrIter_Starts_With
  #define StrIter_Starts_With_t CFISH_StrIter_Starts_With_t
  #define StrIter_Starts_With_Utf8 CFISH_StrIter_Starts_With_Utf8
  #define StrIter_Starts_With_Utf8_t CFISH_StrIter_Starts_With_Utf8_t
  #define StrIter_Ends_With CFISH_StrIter_Ends_With
  #define StrIter_Ends_With_t CFISH_StrIter_Ends_With_t
  #define StrIter_Ends_With_Utf8 CFISH_StrIter_Ends_With_Utf8
  #define StrIter_Ends_With_Utf8_t CFISH_StrIter_Ends_With_Utf8_t
#endif /* CFISH_USE_SHORT_NAMES */



/* Include the header for this class's parent. 
 */

#include "Clownfish/String.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_CFISH_STACKSTRINGITERATOR
extern size_t cfish_SStrIter_IVARS_OFFSET;
typedef struct cfish_StackStringIteratorIVARS cfish_StackStringIteratorIVARS;
static CFISH_INLINE cfish_StackStringIteratorIVARS*
cfish_SStrIter_IVARS(cfish_StackStringIterator *self) {
   char *ptr = (char*)self + cfish_SStrIter_IVARS_OFFSET;
   return (cfish_StackStringIteratorIVARS*)ptr;
}
#ifdef CFISH_USE_SHORT_NAMES
  #define StackStringIteratorIVARS cfish_StackStringIteratorIVARS
  #define SStrIter_IVARS cfish_SStrIter_IVARS
#endif

struct cfish_StackStringIterator {
    CFISH_OBJ_HEAD
    cfish_Class* klass;
    cfish_String* string;
    size_t byte_offset;
};

#endif /* C_CFISH_STACKSTRINGITERATOR */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

CFISH_VISIBLE cfish_StackStringIterator*
cfish_SStrIter_new(void* allocation, cfish_String* string, size_t byte_offset);

void
CFISH_SStrIter_Destroy_IMP(cfish_StackStringIterator* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*CFISH_SStrIter_Get_RefCount_t)(cfish_StackStringIterator *self);

typedef cfish_Obj*
(*CFISH_SStrIter_Inc_RefCount_t)(cfish_StackStringIterator *self);

typedef uint32_t
(*CFISH_SStrIter_Dec_RefCount_t)(cfish_StackStringIterator *self);

typedef void*
(*CFISH_SStrIter_To_Host_t)(cfish_StackStringIterator *self);

typedef cfish_StringIterator*
(*CFISH_SStrIter_Clone_t)(cfish_StackStringIterator *self);

typedef void
(*CFISH_SStrIter_Destroy_t)(cfish_StackStringIterator *self);

typedef bool
(*CFISH_SStrIter_Equals_t)(cfish_StackStringIterator *self, cfish_Obj* other);

typedef int32_t
(*CFISH_SStrIter_Compare_To_t)(cfish_StackStringIterator *self, cfish_Obj* other);

typedef int32_t
(*CFISH_SStrIter_Hash_Sum_t)(cfish_StackStringIterator *self);

typedef cfish_Class*
(*CFISH_SStrIter_Get_Class_t)(cfish_StackStringIterator *self);

typedef cfish_String*
(*CFISH_SStrIter_Get_Class_Name_t)(cfish_StackStringIterator *self);

typedef bool
(*CFISH_SStrIter_Is_A_t)(cfish_StackStringIterator *self, cfish_Class* ancestor);

typedef cfish_String*
(*CFISH_SStrIter_To_String_t)(cfish_StackStringIterator *self);

typedef int64_t
(*CFISH_SStrIter_To_I64_t)(cfish_StackStringIterator *self);

typedef double
(*CFISH_SStrIter_To_F64_t)(cfish_StackStringIterator *self);

typedef bool
(*CFISH_SStrIter_To_Bool_t)(cfish_StackStringIterator *self);

typedef void
(*CFISH_SStrIter_Mimic_t)(cfish_StackStringIterator *self, cfish_Obj* other);

typedef void
(*CFISH_SStrIter_Assign_t)(cfish_StackStringIterator *self, cfish_StringIterator* other);

typedef bool
(*CFISH_SStrIter_Has_Next_t)(cfish_StackStringIterator *self);

typedef bool
(*CFISH_SStrIter_Has_Prev_t)(cfish_StackStringIterator *self);

typedef int32_t
(*CFISH_SStrIter_Next_t)(cfish_StackStringIterator *self);

typedef int32_t
(*CFISH_SStrIter_Prev_t)(cfish_StackStringIterator *self);

typedef size_t
(*CFISH_SStrIter_Advance_t)(cfish_StackStringIterator *self, size_t num);

typedef size_t
(*CFISH_SStrIter_Recede_t)(cfish_StackStringIterator *self, size_t num);

typedef size_t
(*CFISH_SStrIter_Skip_Next_Whitespace_t)(cfish_StackStringIterator *self);

typedef size_t
(*CFISH_SStrIter_Skip_Prev_Whitespace_t)(cfish_StackStringIterator *self);

typedef bool
(*CFISH_SStrIter_Starts_With_t)(cfish_StackStringIterator *self, cfish_String* prefix);

typedef bool
(*CFISH_SStrIter_Starts_With_Utf8_t)(cfish_StackStringIterator *self, const char* prefix, size_t size);

typedef bool
(*CFISH_SStrIter_Ends_With_t)(cfish_StackStringIterator *self, cfish_String* postfix);

typedef bool
(*CFISH_SStrIter_Ends_With_Utf8_t)(cfish_StackStringIterator *self, const char* postfix, size_t size);



/* Define the inline functions which implement this class's virtual methods.
 */

extern CFISH_VISIBLE size_t CFISH_SStrIter_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_SStrIter_Get_RefCount(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_Get_RefCount_t method = (CFISH_SStrIter_Get_RefCount_t)cfish_obj_method(self, CFISH_SStrIter_Get_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_SStrIter_Inc_RefCount(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_Inc_RefCount_t method = (CFISH_SStrIter_Inc_RefCount_t)cfish_obj_method(self, CFISH_SStrIter_Inc_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_SStrIter_Dec_RefCount(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_Dec_RefCount_t method = (CFISH_SStrIter_Dec_RefCount_t)cfish_obj_method(self, CFISH_SStrIter_Dec_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_To_Host_OFFSET;
static CFISH_INLINE void*
CFISH_SStrIter_To_Host(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_To_Host_t method = (CFISH_SStrIter_To_Host_t)cfish_obj_method(self, CFISH_SStrIter_To_Host_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Clone_OFFSET;
static CFISH_INLINE cfish_StringIterator*
CFISH_SStrIter_Clone(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_Clone_t method = (CFISH_SStrIter_Clone_t)cfish_obj_method(self, CFISH_SStrIter_Clone_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Destroy_OFFSET;
static CFISH_INLINE void
CFISH_SStrIter_Destroy(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_Destroy_t method = (CFISH_SStrIter_Destroy_t)cfish_obj_method(self, CFISH_SStrIter_Destroy_OFFSET);
    method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Equals_OFFSET;
static CFISH_INLINE bool
CFISH_SStrIter_Equals(cfish_StackStringIterator *self, cfish_Obj* other) {
    const CFISH_SStrIter_Equals_t method = (CFISH_SStrIter_Equals_t)cfish_obj_method(self, CFISH_SStrIter_Equals_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Compare_To_OFFSET;
static CFISH_INLINE int32_t
CFISH_SStrIter_Compare_To(cfish_StackStringIterator *self, cfish_Obj* other) {
    const CFISH_SStrIter_Compare_To_t method = (CFISH_SStrIter_Compare_To_t)cfish_obj_method(self, CFISH_SStrIter_Compare_To_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
CFISH_SStrIter_Hash_Sum(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_Hash_Sum_t method = (CFISH_SStrIter_Hash_Sum_t)cfish_obj_method(self, CFISH_SStrIter_Hash_Sum_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
CFISH_SStrIter_Get_Class(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_Get_Class_t method = (CFISH_SStrIter_Get_Class_t)cfish_obj_method(self, CFISH_SStrIter_Get_Class_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_SStrIter_Get_Class_Name(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_Get_Class_Name_t method = (CFISH_SStrIter_Get_Class_Name_t)cfish_obj_method(self, CFISH_SStrIter_Get_Class_Name_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Is_A_OFFSET;
static CFISH_INLINE bool
CFISH_SStrIter_Is_A(cfish_StackStringIterator *self, cfish_Class* ancestor) {
    const CFISH_SStrIter_Is_A_t method = (CFISH_SStrIter_Is_A_t)cfish_obj_method(self, CFISH_SStrIter_Is_A_OFFSET);
    return method(self, ancestor);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_To_String_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_SStrIter_To_String(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_To_String_t method = (CFISH_SStrIter_To_String_t)cfish_obj_method(self, CFISH_SStrIter_To_String_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_To_I64_OFFSET;
static CFISH_INLINE int64_t
CFISH_SStrIter_To_I64(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_To_I64_t method = (CFISH_SStrIter_To_I64_t)cfish_obj_method(self, CFISH_SStrIter_To_I64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_To_F64_OFFSET;
static CFISH_INLINE double
CFISH_SStrIter_To_F64(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_To_F64_t method = (CFISH_SStrIter_To_F64_t)cfish_obj_method(self, CFISH_SStrIter_To_F64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_To_Bool_OFFSET;
static CFISH_INLINE bool
CFISH_SStrIter_To_Bool(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_To_Bool_t method = (CFISH_SStrIter_To_Bool_t)cfish_obj_method(self, CFISH_SStrIter_To_Bool_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Mimic_OFFSET;
static CFISH_INLINE void
CFISH_SStrIter_Mimic(cfish_StackStringIterator *self, cfish_Obj* other) {
    const CFISH_SStrIter_Mimic_t method = (CFISH_SStrIter_Mimic_t)cfish_obj_method(self, CFISH_SStrIter_Mimic_OFFSET);
    method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Assign_OFFSET;
static CFISH_INLINE void
CFISH_SStrIter_Assign(cfish_StackStringIterator *self, cfish_StringIterator* other) {
    const CFISH_SStrIter_Assign_t method = (CFISH_SStrIter_Assign_t)cfish_obj_method(self, CFISH_SStrIter_Assign_OFFSET);
    method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Has_Next_OFFSET;
static CFISH_INLINE bool
CFISH_SStrIter_Has_Next(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_Has_Next_t method = (CFISH_SStrIter_Has_Next_t)cfish_obj_method(self, CFISH_SStrIter_Has_Next_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Has_Prev_OFFSET;
static CFISH_INLINE bool
CFISH_SStrIter_Has_Prev(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_Has_Prev_t method = (CFISH_SStrIter_Has_Prev_t)cfish_obj_method(self, CFISH_SStrIter_Has_Prev_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Next_OFFSET;
static CFISH_INLINE int32_t
CFISH_SStrIter_Next(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_Next_t method = (CFISH_SStrIter_Next_t)cfish_obj_method(self, CFISH_SStrIter_Next_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Prev_OFFSET;
static CFISH_INLINE int32_t
CFISH_SStrIter_Prev(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_Prev_t method = (CFISH_SStrIter_Prev_t)cfish_obj_method(self, CFISH_SStrIter_Prev_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Advance_OFFSET;
static CFISH_INLINE size_t
CFISH_SStrIter_Advance(cfish_StackStringIterator *self, size_t num) {
    const CFISH_SStrIter_Advance_t method = (CFISH_SStrIter_Advance_t)cfish_obj_method(self, CFISH_SStrIter_Advance_OFFSET);
    return method(self, num);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Recede_OFFSET;
static CFISH_INLINE size_t
CFISH_SStrIter_Recede(cfish_StackStringIterator *self, size_t num) {
    const CFISH_SStrIter_Recede_t method = (CFISH_SStrIter_Recede_t)cfish_obj_method(self, CFISH_SStrIter_Recede_OFFSET);
    return method(self, num);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Skip_Next_Whitespace_OFFSET;
static CFISH_INLINE size_t
CFISH_SStrIter_Skip_Next_Whitespace(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_Skip_Next_Whitespace_t method = (CFISH_SStrIter_Skip_Next_Whitespace_t)cfish_obj_method(self, CFISH_SStrIter_Skip_Next_Whitespace_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Skip_Prev_Whitespace_OFFSET;
static CFISH_INLINE size_t
CFISH_SStrIter_Skip_Prev_Whitespace(cfish_StackStringIterator *self) {
    const CFISH_SStrIter_Skip_Prev_Whitespace_t method = (CFISH_SStrIter_Skip_Prev_Whitespace_t)cfish_obj_method(self, CFISH_SStrIter_Skip_Prev_Whitespace_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Starts_With_OFFSET;
static CFISH_INLINE bool
CFISH_SStrIter_Starts_With(cfish_StackStringIterator *self, cfish_String* prefix) {
    const CFISH_SStrIter_Starts_With_t method = (CFISH_SStrIter_Starts_With_t)cfish_obj_method(self, CFISH_SStrIter_Starts_With_OFFSET);
    return method(self, prefix);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Starts_With_Utf8_OFFSET;
static CFISH_INLINE bool
CFISH_SStrIter_Starts_With_Utf8(cfish_StackStringIterator *self, const char* prefix, size_t size) {
    const CFISH_SStrIter_Starts_With_Utf8_t method = (CFISH_SStrIter_Starts_With_Utf8_t)cfish_obj_method(self, CFISH_SStrIter_Starts_With_Utf8_OFFSET);
    return method(self, prefix, size);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Ends_With_OFFSET;
static CFISH_INLINE bool
CFISH_SStrIter_Ends_With(cfish_StackStringIterator *self, cfish_String* postfix) {
    const CFISH_SStrIter_Ends_With_t method = (CFISH_SStrIter_Ends_With_t)cfish_obj_method(self, CFISH_SStrIter_Ends_With_OFFSET);
    return method(self, postfix);
}

extern CFISH_VISIBLE size_t CFISH_SStrIter_Ends_With_Utf8_OFFSET;
static CFISH_INLINE bool
CFISH_SStrIter_Ends_With_Utf8(cfish_StackStringIterator *self, const char* postfix, size_t size) {
    const CFISH_SStrIter_Ends_With_Utf8_t method = (CFISH_SStrIter_Ends_With_Utf8_t)cfish_obj_method(self, CFISH_SStrIter_Ends_With_Utf8_OFFSET);
    return method(self, postfix, size);
}



/* Declare the Class singleton for this class.
 */

extern CFISH_VISIBLE cfish_Class *CFISH_STACKSTRINGITERATOR;

/* Define "short names" for this class's symbols.
 */

#ifdef CFISH_USE_SHORT_NAMES
  #define StackStringIterator cfish_StackStringIterator
  #define STACKSTRINGITERATOR CFISH_STACKSTRINGITERATOR
  #define SStrIter_new cfish_SStrIter_new
  #define SStrIter_Destroy_IMP CFISH_SStrIter_Destroy_IMP
  #define SStrIter_Get_RefCount CFISH_SStrIter_Get_RefCount
  #define SStrIter_Get_RefCount_t CFISH_SStrIter_Get_RefCount_t
  #define SStrIter_Inc_RefCount CFISH_SStrIter_Inc_RefCount
  #define SStrIter_Inc_RefCount_t CFISH_SStrIter_Inc_RefCount_t
  #define SStrIter_Dec_RefCount CFISH_SStrIter_Dec_RefCount
  #define SStrIter_Dec_RefCount_t CFISH_SStrIter_Dec_RefCount_t
  #define SStrIter_To_Host CFISH_SStrIter_To_Host
  #define SStrIter_To_Host_t CFISH_SStrIter_To_Host_t
  #define SStrIter_Clone CFISH_SStrIter_Clone
  #define SStrIter_Clone_t CFISH_SStrIter_Clone_t
  #define SStrIter_Destroy CFISH_SStrIter_Destroy
  #define SStrIter_Destroy_t CFISH_SStrIter_Destroy_t
  #define SStrIter_Equals CFISH_SStrIter_Equals
  #define SStrIter_Equals_t CFISH_SStrIter_Equals_t
  #define SStrIter_Compare_To CFISH_SStrIter_Compare_To
  #define SStrIter_Compare_To_t CFISH_SStrIter_Compare_To_t
  #define SStrIter_Hash_Sum CFISH_SStrIter_Hash_Sum
  #define SStrIter_Hash_Sum_t CFISH_SStrIter_Hash_Sum_t
  #define SStrIter_Get_Class CFISH_SStrIter_Get_Class
  #define SStrIter_Get_Class_t CFISH_SStrIter_Get_Class_t
  #define SStrIter_Get_Class_Name CFISH_SStrIter_Get_Class_Name
  #define SStrIter_Get_Class_Name_t CFISH_SStrIter_Get_Class_Name_t
  #define SStrIter_Is_A CFISH_SStrIter_Is_A
  #define SStrIter_Is_A_t CFISH_SStrIter_Is_A_t
  #define SStrIter_To_String CFISH_SStrIter_To_String
  #define SStrIter_To_String_t CFISH_SStrIter_To_String_t
  #define SStrIter_To_I64 CFISH_SStrIter_To_I64
  #define SStrIter_To_I64_t CFISH_SStrIter_To_I64_t
  #define SStrIter_To_F64 CFISH_SStrIter_To_F64
  #define SStrIter_To_F64_t CFISH_SStrIter_To_F64_t
  #define SStrIter_To_Bool CFISH_SStrIter_To_Bool
  #define SStrIter_To_Bool_t CFISH_SStrIter_To_Bool_t
  #define SStrIter_Mimic CFISH_SStrIter_Mimic
  #define SStrIter_Mimic_t CFISH_SStrIter_Mimic_t
  #define SStrIter_Assign CFISH_SStrIter_Assign
  #define SStrIter_Assign_t CFISH_SStrIter_Assign_t
  #define SStrIter_Has_Next CFISH_SStrIter_Has_Next
  #define SStrIter_Has_Next_t CFISH_SStrIter_Has_Next_t
  #define SStrIter_Has_Prev CFISH_SStrIter_Has_Prev
  #define SStrIter_Has_Prev_t CFISH_SStrIter_Has_Prev_t
  #define SStrIter_Next CFISH_SStrIter_Next
  #define SStrIter_Next_t CFISH_SStrIter_Next_t
  #define SStrIter_Prev CFISH_SStrIter_Prev
  #define SStrIter_Prev_t CFISH_SStrIter_Prev_t
  #define SStrIter_Advance CFISH_SStrIter_Advance
  #define SStrIter_Advance_t CFISH_SStrIter_Advance_t
  #define SStrIter_Recede CFISH_SStrIter_Recede
  #define SStrIter_Recede_t CFISH_SStrIter_Recede_t
  #define SStrIter_Skip_Next_Whitespace CFISH_SStrIter_Skip_Next_Whitespace
  #define SStrIter_Skip_Next_Whitespace_t CFISH_SStrIter_Skip_Next_Whitespace_t
  #define SStrIter_Skip_Prev_Whitespace CFISH_SStrIter_Skip_Prev_Whitespace
  #define SStrIter_Skip_Prev_Whitespace_t CFISH_SStrIter_Skip_Prev_Whitespace_t
  #define SStrIter_Starts_With CFISH_SStrIter_Starts_With
  #define SStrIter_Starts_With_t CFISH_SStrIter_Starts_With_t
  #define SStrIter_Starts_With_Utf8 CFISH_SStrIter_Starts_With_Utf8
  #define SStrIter_Starts_With_Utf8_t CFISH_SStrIter_Starts_With_Utf8_t
  #define SStrIter_Ends_With CFISH_SStrIter_Ends_With
  #define SStrIter_Ends_With_t CFISH_SStrIter_Ends_With_t
  #define SStrIter_Ends_With_Utf8 CFISH_SStrIter_Ends_With_Utf8
  #define SStrIter_Ends_With_Utf8_t CFISH_SStrIter_Ends_With_Utf8_t
#endif /* CFISH_USE_SHORT_NAMES */



#define CFISH_SSTR_BLANK() \
   cfish_SStr_wrap_str(cfish_alloca(cfish_SStr_size()), "", 0)

#define CFISH_SSTR_WRAP(source) \
    cfish_SStr_wrap(cfish_alloca(cfish_SStr_size()), source)

#define CFISH_SSTR_WRAP_UTF8(ptr, size) \
    cfish_SStr_wrap_str(cfish_alloca(cfish_SStr_size()), ptr, size)

#define CFISH_STRITER_DONE  -1

#ifdef CFISH_USE_SHORT_NAMES
  #define SSTR_BLANK             CFISH_SSTR_BLANK
  #define SSTR_WRAP              CFISH_SSTR_WRAP
  #define SSTR_WRAP_UTF8         CFISH_SSTR_WRAP_UTF8
  #define STRITER_DONE           CFISH_STRITER_DONE
#endif



#ifdef __cplusplus
}
#endif

#endif /* H_CLOWNFISH_STRING */




