/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_CLOWNFISH_VARRAY
#define H_CLOWNFISH_VARRAY 1


#ifdef __cplusplus
extern "C" {
#endif

#include "cfish_parcel.h"

#include "Clownfish/Util/SortUtils.h"

typedef bool
(*CFISH_VA_Gather_Test_t)(cfish_VArray *self, uint32_t tick, void *data);

#ifdef CFISH_USE_SHORT_NAMES
  #define VA_Gather_Test_t CFISH_VA_Gather_Test_t
#endif

/* Include the header for this class's parent. 
 */

#include "Clownfish/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_CFISH_VARRAY
extern size_t cfish_VA_IVARS_OFFSET;
typedef struct cfish_VArrayIVARS cfish_VArrayIVARS;
static CFISH_INLINE cfish_VArrayIVARS*
cfish_VA_IVARS(cfish_VArray *self) {
   char *ptr = (char*)self + cfish_VA_IVARS_OFFSET;
   return (cfish_VArrayIVARS*)ptr;
}
#ifdef CFISH_USE_SHORT_NAMES
  #define VArrayIVARS cfish_VArrayIVARS
  #define VA_IVARS cfish_VA_IVARS
#endif

struct cfish_VArray {
    CFISH_OBJ_HEAD
    cfish_Class* klass;
    cfish_Obj** elems;
    uint32_t size;
    uint32_t cap;
};

#endif /* C_CFISH_VARRAY */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

CFISH_VISIBLE cfish_VArray*
cfish_VA_new(uint32_t capacity);

CFISH_VISIBLE cfish_VArray*
cfish_VA_init(cfish_VArray* self, uint32_t capacity);

cfish_VArray*
CFISH_VA_Clone_IMP(cfish_VArray* self);

void
CFISH_VA_Destroy_IMP(cfish_VArray* self);

bool
CFISH_VA_Equals_IMP(cfish_VArray* self, cfish_Obj* other);

void
CFISH_VA_Push_IMP(cfish_VArray* self, cfish_Obj* element);

void
CFISH_VA_Push_VArray_IMP(cfish_VArray* self, cfish_VArray* other);

cfish_Obj*
CFISH_VA_Pop_IMP(cfish_VArray* self);

void
CFISH_VA_Unshift_IMP(cfish_VArray* self, cfish_Obj* element);

cfish_Obj*
CFISH_VA_Shift_IMP(cfish_VArray* self);

void
CFISH_VA_Grow_IMP(cfish_VArray* self, uint32_t capacity);

cfish_Obj*
CFISH_VA_Fetch_IMP(cfish_VArray* self, uint32_t tick);

void
CFISH_VA_Store_IMP(cfish_VArray* self, uint32_t tick, cfish_Obj* elem);

cfish_Obj*
CFISH_VA_Delete_IMP(cfish_VArray* self, uint32_t tick);

void
CFISH_VA_Excise_IMP(cfish_VArray* self, uint32_t offset, uint32_t length);

cfish_VArray*
CFISH_VA_Shallow_Copy_IMP(cfish_VArray* self);

void
CFISH_VA_Sort_IMP(cfish_VArray* self, CFISH_Sort_Compare_t compare, void* context);

void
CFISH_VA_Resize_IMP(cfish_VArray* self, uint32_t size);

void
CFISH_VA_Clear_IMP(cfish_VArray* self);

uint32_t
CFISH_VA_Get_Size_IMP(cfish_VArray* self);

uint32_t
CFISH_VA_Get_Capacity_IMP(cfish_VArray* self);

cfish_VArray*
CFISH_VA_Gather_IMP(cfish_VArray* self, CFISH_VA_Gather_Test_t test, void* data);

cfish_VArray*
CFISH_VA_Slice_IMP(cfish_VArray* self, uint32_t offset, uint32_t length);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*CFISH_VA_Get_RefCount_t)(cfish_VArray *self);

typedef cfish_Obj*
(*CFISH_VA_Inc_RefCount_t)(cfish_VArray *self);

typedef uint32_t
(*CFISH_VA_Dec_RefCount_t)(cfish_VArray *self);

typedef void*
(*CFISH_VA_To_Host_t)(cfish_VArray *self);

typedef cfish_VArray*
(*CFISH_VA_Clone_t)(cfish_VArray *self);

typedef void
(*CFISH_VA_Destroy_t)(cfish_VArray *self);

typedef bool
(*CFISH_VA_Equals_t)(cfish_VArray *self, cfish_Obj* other);

typedef int32_t
(*CFISH_VA_Compare_To_t)(cfish_VArray *self, cfish_Obj* other);

typedef int32_t
(*CFISH_VA_Hash_Sum_t)(cfish_VArray *self);

typedef cfish_Class*
(*CFISH_VA_Get_Class_t)(cfish_VArray *self);

typedef cfish_String*
(*CFISH_VA_Get_Class_Name_t)(cfish_VArray *self);

typedef bool
(*CFISH_VA_Is_A_t)(cfish_VArray *self, cfish_Class* ancestor);

typedef cfish_String*
(*CFISH_VA_To_String_t)(cfish_VArray *self);

typedef int64_t
(*CFISH_VA_To_I64_t)(cfish_VArray *self);

typedef double
(*CFISH_VA_To_F64_t)(cfish_VArray *self);

typedef bool
(*CFISH_VA_To_Bool_t)(cfish_VArray *self);

typedef void
(*CFISH_VA_Mimic_t)(cfish_VArray *self, cfish_Obj* other);

typedef void
(*CFISH_VA_Push_t)(cfish_VArray *self, cfish_Obj* element);

typedef void
(*CFISH_VA_Push_VArray_t)(cfish_VArray *self, cfish_VArray* other);

typedef cfish_Obj*
(*CFISH_VA_Pop_t)(cfish_VArray *self);

typedef void
(*CFISH_VA_Unshift_t)(cfish_VArray *self, cfish_Obj* element);

typedef cfish_Obj*
(*CFISH_VA_Shift_t)(cfish_VArray *self);

typedef void
(*CFISH_VA_Grow_t)(cfish_VArray *self, uint32_t capacity);

typedef cfish_Obj*
(*CFISH_VA_Fetch_t)(cfish_VArray *self, uint32_t tick);

typedef void
(*CFISH_VA_Store_t)(cfish_VArray *self, uint32_t tick, cfish_Obj* elem);

typedef cfish_Obj*
(*CFISH_VA_Delete_t)(cfish_VArray *self, uint32_t tick);

typedef void
(*CFISH_VA_Excise_t)(cfish_VArray *self, uint32_t offset, uint32_t length);

typedef cfish_VArray*
(*CFISH_VA_Shallow_Copy_t)(cfish_VArray *self);

typedef void
(*CFISH_VA_Sort_t)(cfish_VArray *self, CFISH_Sort_Compare_t compare, void* context);

typedef void
(*CFISH_VA_Resize_t)(cfish_VArray *self, uint32_t size);

typedef void
(*CFISH_VA_Clear_t)(cfish_VArray *self);

typedef uint32_t
(*CFISH_VA_Get_Size_t)(cfish_VArray *self);

typedef uint32_t
(*CFISH_VA_Get_Capacity_t)(cfish_VArray *self);

typedef cfish_VArray*
(*CFISH_VA_Gather_t)(cfish_VArray *self, CFISH_VA_Gather_Test_t test, void* data);

typedef cfish_VArray*
(*CFISH_VA_Slice_t)(cfish_VArray *self, uint32_t offset, uint32_t length);



/* Define the inline functions which implement this class's virtual methods.
 */

extern CFISH_VISIBLE size_t CFISH_VA_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_VA_Get_RefCount(cfish_VArray *self) {
    const CFISH_VA_Get_RefCount_t method = (CFISH_VA_Get_RefCount_t)cfish_obj_method(self, CFISH_VA_Get_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_VA_Inc_RefCount(cfish_VArray *self) {
    const CFISH_VA_Inc_RefCount_t method = (CFISH_VA_Inc_RefCount_t)cfish_obj_method(self, CFISH_VA_Inc_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_VA_Dec_RefCount(cfish_VArray *self) {
    const CFISH_VA_Dec_RefCount_t method = (CFISH_VA_Dec_RefCount_t)cfish_obj_method(self, CFISH_VA_Dec_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_To_Host_OFFSET;
static CFISH_INLINE void*
CFISH_VA_To_Host(cfish_VArray *self) {
    const CFISH_VA_To_Host_t method = (CFISH_VA_To_Host_t)cfish_obj_method(self, CFISH_VA_To_Host_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Clone_OFFSET;
static CFISH_INLINE cfish_VArray*
CFISH_VA_Clone(cfish_VArray *self) {
    const CFISH_VA_Clone_t method = (CFISH_VA_Clone_t)cfish_obj_method(self, CFISH_VA_Clone_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Destroy_OFFSET;
static CFISH_INLINE void
CFISH_VA_Destroy(cfish_VArray *self) {
    const CFISH_VA_Destroy_t method = (CFISH_VA_Destroy_t)cfish_obj_method(self, CFISH_VA_Destroy_OFFSET);
    method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Equals_OFFSET;
static CFISH_INLINE bool
CFISH_VA_Equals(cfish_VArray *self, cfish_Obj* other) {
    const CFISH_VA_Equals_t method = (CFISH_VA_Equals_t)cfish_obj_method(self, CFISH_VA_Equals_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_VA_Compare_To_OFFSET;
static CFISH_INLINE int32_t
CFISH_VA_Compare_To(cfish_VArray *self, cfish_Obj* other) {
    const CFISH_VA_Compare_To_t method = (CFISH_VA_Compare_To_t)cfish_obj_method(self, CFISH_VA_Compare_To_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_VA_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
CFISH_VA_Hash_Sum(cfish_VArray *self) {
    const CFISH_VA_Hash_Sum_t method = (CFISH_VA_Hash_Sum_t)cfish_obj_method(self, CFISH_VA_Hash_Sum_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
CFISH_VA_Get_Class(cfish_VArray *self) {
    const CFISH_VA_Get_Class_t method = (CFISH_VA_Get_Class_t)cfish_obj_method(self, CFISH_VA_Get_Class_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_VA_Get_Class_Name(cfish_VArray *self) {
    const CFISH_VA_Get_Class_Name_t method = (CFISH_VA_Get_Class_Name_t)cfish_obj_method(self, CFISH_VA_Get_Class_Name_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Is_A_OFFSET;
static CFISH_INLINE bool
CFISH_VA_Is_A(cfish_VArray *self, cfish_Class* ancestor) {
    const CFISH_VA_Is_A_t method = (CFISH_VA_Is_A_t)cfish_obj_method(self, CFISH_VA_Is_A_OFFSET);
    return method(self, ancestor);
}

extern CFISH_VISIBLE size_t CFISH_VA_To_String_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_VA_To_String(cfish_VArray *self) {
    const CFISH_VA_To_String_t method = (CFISH_VA_To_String_t)cfish_obj_method(self, CFISH_VA_To_String_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_To_I64_OFFSET;
static CFISH_INLINE int64_t
CFISH_VA_To_I64(cfish_VArray *self) {
    const CFISH_VA_To_I64_t method = (CFISH_VA_To_I64_t)cfish_obj_method(self, CFISH_VA_To_I64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_To_F64_OFFSET;
static CFISH_INLINE double
CFISH_VA_To_F64(cfish_VArray *self) {
    const CFISH_VA_To_F64_t method = (CFISH_VA_To_F64_t)cfish_obj_method(self, CFISH_VA_To_F64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_To_Bool_OFFSET;
static CFISH_INLINE bool
CFISH_VA_To_Bool(cfish_VArray *self) {
    const CFISH_VA_To_Bool_t method = (CFISH_VA_To_Bool_t)cfish_obj_method(self, CFISH_VA_To_Bool_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Mimic_OFFSET;
static CFISH_INLINE void
CFISH_VA_Mimic(cfish_VArray *self, cfish_Obj* other) {
    const CFISH_VA_Mimic_t method = (CFISH_VA_Mimic_t)cfish_obj_method(self, CFISH_VA_Mimic_OFFSET);
    method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_VA_Push_OFFSET;
static CFISH_INLINE void
CFISH_VA_Push(cfish_VArray *self, cfish_Obj* element) {
    const CFISH_VA_Push_t method = (CFISH_VA_Push_t)cfish_obj_method(self, CFISH_VA_Push_OFFSET);
    method(self, element);
}

extern CFISH_VISIBLE size_t CFISH_VA_Push_VArray_OFFSET;
static CFISH_INLINE void
CFISH_VA_Push_VArray(cfish_VArray *self, cfish_VArray* other) {
    const CFISH_VA_Push_VArray_t method = (CFISH_VA_Push_VArray_t)cfish_obj_method(self, CFISH_VA_Push_VArray_OFFSET);
    method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_VA_Pop_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_VA_Pop(cfish_VArray *self) {
    const CFISH_VA_Pop_t method = (CFISH_VA_Pop_t)cfish_obj_method(self, CFISH_VA_Pop_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Unshift_OFFSET;
static CFISH_INLINE void
CFISH_VA_Unshift(cfish_VArray *self, cfish_Obj* element) {
    const CFISH_VA_Unshift_t method = (CFISH_VA_Unshift_t)cfish_obj_method(self, CFISH_VA_Unshift_OFFSET);
    method(self, element);
}

extern CFISH_VISIBLE size_t CFISH_VA_Shift_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_VA_Shift(cfish_VArray *self) {
    const CFISH_VA_Shift_t method = (CFISH_VA_Shift_t)cfish_obj_method(self, CFISH_VA_Shift_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Grow_OFFSET;
static CFISH_INLINE void
CFISH_VA_Grow(cfish_VArray *self, uint32_t capacity) {
    const CFISH_VA_Grow_t method = (CFISH_VA_Grow_t)cfish_obj_method(self, CFISH_VA_Grow_OFFSET);
    method(self, capacity);
}

extern CFISH_VISIBLE size_t CFISH_VA_Fetch_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_VA_Fetch(cfish_VArray *self, uint32_t tick) {
    const CFISH_VA_Fetch_t method = (CFISH_VA_Fetch_t)cfish_obj_method(self, CFISH_VA_Fetch_OFFSET);
    return method(self, tick);
}

extern CFISH_VISIBLE size_t CFISH_VA_Store_OFFSET;
static CFISH_INLINE void
CFISH_VA_Store(cfish_VArray *self, uint32_t tick, cfish_Obj* elem) {
    const CFISH_VA_Store_t method = (CFISH_VA_Store_t)cfish_obj_method(self, CFISH_VA_Store_OFFSET);
    method(self, tick, elem);
}

extern CFISH_VISIBLE size_t CFISH_VA_Delete_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_VA_Delete(cfish_VArray *self, uint32_t tick) {
    const CFISH_VA_Delete_t method = (CFISH_VA_Delete_t)cfish_obj_method(self, CFISH_VA_Delete_OFFSET);
    return method(self, tick);
}

extern CFISH_VISIBLE size_t CFISH_VA_Excise_OFFSET;
static CFISH_INLINE void
CFISH_VA_Excise(cfish_VArray *self, uint32_t offset, uint32_t length) {
    const CFISH_VA_Excise_t method = (CFISH_VA_Excise_t)cfish_obj_method(self, CFISH_VA_Excise_OFFSET);
    method(self, offset, length);
}

extern CFISH_VISIBLE size_t CFISH_VA_Shallow_Copy_OFFSET;
static CFISH_INLINE cfish_VArray*
CFISH_VA_Shallow_Copy(cfish_VArray *self) {
    const CFISH_VA_Shallow_Copy_t method = (CFISH_VA_Shallow_Copy_t)cfish_obj_method(self, CFISH_VA_Shallow_Copy_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Sort_OFFSET;
static CFISH_INLINE void
CFISH_VA_Sort(cfish_VArray *self, CFISH_Sort_Compare_t compare, void* context) {
    const CFISH_VA_Sort_t method = (CFISH_VA_Sort_t)cfish_obj_method(self, CFISH_VA_Sort_OFFSET);
    method(self, compare, context);
}

extern CFISH_VISIBLE size_t CFISH_VA_Resize_OFFSET;
static CFISH_INLINE void
CFISH_VA_Resize(cfish_VArray *self, uint32_t size) {
    const CFISH_VA_Resize_t method = (CFISH_VA_Resize_t)cfish_obj_method(self, CFISH_VA_Resize_OFFSET);
    method(self, size);
}

extern CFISH_VISIBLE size_t CFISH_VA_Clear_OFFSET;
static CFISH_INLINE void
CFISH_VA_Clear(cfish_VArray *self) {
    const CFISH_VA_Clear_t method = (CFISH_VA_Clear_t)cfish_obj_method(self, CFISH_VA_Clear_OFFSET);
    method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Get_Size_OFFSET;
static CFISH_INLINE uint32_t
CFISH_VA_Get_Size(cfish_VArray *self) {
    const CFISH_VA_Get_Size_t method = (CFISH_VA_Get_Size_t)cfish_obj_method(self, CFISH_VA_Get_Size_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Get_Capacity_OFFSET;
static CFISH_INLINE uint32_t
CFISH_VA_Get_Capacity(cfish_VArray *self) {
    const CFISH_VA_Get_Capacity_t method = (CFISH_VA_Get_Capacity_t)cfish_obj_method(self, CFISH_VA_Get_Capacity_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_VA_Gather_OFFSET;
static CFISH_INLINE cfish_VArray*
CFISH_VA_Gather(cfish_VArray *self, CFISH_VA_Gather_Test_t test, void* data) {
    const CFISH_VA_Gather_t method = (CFISH_VA_Gather_t)cfish_obj_method(self, CFISH_VA_Gather_OFFSET);
    return method(self, test, data);
}

extern CFISH_VISIBLE size_t CFISH_VA_Slice_OFFSET;
static CFISH_INLINE cfish_VArray*
CFISH_VA_Slice(cfish_VArray *self, uint32_t offset, uint32_t length) {
    const CFISH_VA_Slice_t method = (CFISH_VA_Slice_t)cfish_obj_method(self, CFISH_VA_Slice_OFFSET);
    return method(self, offset, length);
}



/* Declare the Class singleton for this class.
 */

extern CFISH_VISIBLE cfish_Class *CFISH_VARRAY;

/* Define "short names" for this class's symbols.
 */

#ifdef CFISH_USE_SHORT_NAMES
  #define VArray cfish_VArray
  #define VARRAY CFISH_VARRAY
  #define VA_new cfish_VA_new
  #define VA_init cfish_VA_init
  #define VA_Clone_IMP CFISH_VA_Clone_IMP
  #define VA_Destroy_IMP CFISH_VA_Destroy_IMP
  #define VA_Equals_IMP CFISH_VA_Equals_IMP
  #define VA_Push_IMP CFISH_VA_Push_IMP
  #define VA_Push_VArray_IMP CFISH_VA_Push_VArray_IMP
  #define VA_Pop_IMP CFISH_VA_Pop_IMP
  #define VA_Unshift_IMP CFISH_VA_Unshift_IMP
  #define VA_Shift_IMP CFISH_VA_Shift_IMP
  #define VA_Grow_IMP CFISH_VA_Grow_IMP
  #define VA_Fetch_IMP CFISH_VA_Fetch_IMP
  #define VA_Store_IMP CFISH_VA_Store_IMP
  #define VA_Delete_IMP CFISH_VA_Delete_IMP
  #define VA_Excise_IMP CFISH_VA_Excise_IMP
  #define VA_Shallow_Copy_IMP CFISH_VA_Shallow_Copy_IMP
  #define VA_Sort_IMP CFISH_VA_Sort_IMP
  #define VA_Resize_IMP CFISH_VA_Resize_IMP
  #define VA_Clear_IMP CFISH_VA_Clear_IMP
  #define VA_Get_Size_IMP CFISH_VA_Get_Size_IMP
  #define VA_Get_Capacity_IMP CFISH_VA_Get_Capacity_IMP
  #define VA_Gather_IMP CFISH_VA_Gather_IMP
  #define VA_Slice_IMP CFISH_VA_Slice_IMP
  #define VA_Get_RefCount CFISH_VA_Get_RefCount
  #define VA_Get_RefCount_t CFISH_VA_Get_RefCount_t
  #define VA_Inc_RefCount CFISH_VA_Inc_RefCount
  #define VA_Inc_RefCount_t CFISH_VA_Inc_RefCount_t
  #define VA_Dec_RefCount CFISH_VA_Dec_RefCount
  #define VA_Dec_RefCount_t CFISH_VA_Dec_RefCount_t
  #define VA_To_Host CFISH_VA_To_Host
  #define VA_To_Host_t CFISH_VA_To_Host_t
  #define VA_Clone CFISH_VA_Clone
  #define VA_Clone_t CFISH_VA_Clone_t
  #define VA_Destroy CFISH_VA_Destroy
  #define VA_Destroy_t CFISH_VA_Destroy_t
  #define VA_Equals CFISH_VA_Equals
  #define VA_Equals_t CFISH_VA_Equals_t
  #define VA_Compare_To CFISH_VA_Compare_To
  #define VA_Compare_To_t CFISH_VA_Compare_To_t
  #define VA_Hash_Sum CFISH_VA_Hash_Sum
  #define VA_Hash_Sum_t CFISH_VA_Hash_Sum_t
  #define VA_Get_Class CFISH_VA_Get_Class
  #define VA_Get_Class_t CFISH_VA_Get_Class_t
  #define VA_Get_Class_Name CFISH_VA_Get_Class_Name
  #define VA_Get_Class_Name_t CFISH_VA_Get_Class_Name_t
  #define VA_Is_A CFISH_VA_Is_A
  #define VA_Is_A_t CFISH_VA_Is_A_t
  #define VA_To_String CFISH_VA_To_String
  #define VA_To_String_t CFISH_VA_To_String_t
  #define VA_To_I64 CFISH_VA_To_I64
  #define VA_To_I64_t CFISH_VA_To_I64_t
  #define VA_To_F64 CFISH_VA_To_F64
  #define VA_To_F64_t CFISH_VA_To_F64_t
  #define VA_To_Bool CFISH_VA_To_Bool
  #define VA_To_Bool_t CFISH_VA_To_Bool_t
  #define VA_Mimic CFISH_VA_Mimic
  #define VA_Mimic_t CFISH_VA_Mimic_t
  #define VA_Push CFISH_VA_Push
  #define VA_Push_t CFISH_VA_Push_t
  #define VA_Push_VArray CFISH_VA_Push_VArray
  #define VA_Push_VArray_t CFISH_VA_Push_VArray_t
  #define VA_Pop CFISH_VA_Pop
  #define VA_Pop_t CFISH_VA_Pop_t
  #define VA_Unshift CFISH_VA_Unshift
  #define VA_Unshift_t CFISH_VA_Unshift_t
  #define VA_Shift CFISH_VA_Shift
  #define VA_Shift_t CFISH_VA_Shift_t
  #define VA_Grow CFISH_VA_Grow
  #define VA_Grow_t CFISH_VA_Grow_t
  #define VA_Fetch CFISH_VA_Fetch
  #define VA_Fetch_t CFISH_VA_Fetch_t
  #define VA_Store CFISH_VA_Store
  #define VA_Store_t CFISH_VA_Store_t
  #define VA_Delete CFISH_VA_Delete
  #define VA_Delete_t CFISH_VA_Delete_t
  #define VA_Excise CFISH_VA_Excise
  #define VA_Excise_t CFISH_VA_Excise_t
  #define VA_Shallow_Copy CFISH_VA_Shallow_Copy
  #define VA_Shallow_Copy_t CFISH_VA_Shallow_Copy_t
  #define VA_Sort CFISH_VA_Sort
  #define VA_Sort_t CFISH_VA_Sort_t
  #define VA_Resize CFISH_VA_Resize
  #define VA_Resize_t CFISH_VA_Resize_t
  #define VA_Clear CFISH_VA_Clear
  #define VA_Clear_t CFISH_VA_Clear_t
  #define VA_Get_Size CFISH_VA_Get_Size
  #define VA_Get_Size_t CFISH_VA_Get_Size_t
  #define VA_Get_Capacity CFISH_VA_Get_Capacity
  #define VA_Get_Capacity_t CFISH_VA_Get_Capacity_t
  #define VA_Gather CFISH_VA_Gather
  #define VA_Gather_t CFISH_VA_Gather_t
  #define VA_Slice CFISH_VA_Slice
  #define VA_Slice_t CFISH_VA_Slice_t
#endif /* CFISH_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_CLOWNFISH_VARRAY */




