/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef CFISH_CFISH_PARCEL_H
#define CFISH_CFISH_PARCEL_H 1

#ifdef __cplusplus
extern "C" {
#endif

#include <stdarg.h>
#include <stddef.h>

#include "cfish_platform.h"
#include "cfish_hostdefs.h"

#ifdef CFP_CFISH
  #define CFISH_VISIBLE CFISH_EXPORT
#else
  #define CFISH_VISIBLE CFISH_IMPORT
#endif

typedef struct cfish_Obj cfish_Obj;
typedef struct cfish_Class cfish_Class;
typedef struct cfish_String cfish_String;
typedef struct cfish_StackString cfish_StackString;
typedef struct cfish_StringIterator cfish_StringIterator;
typedef struct cfish_StackStringIterator cfish_StackStringIterator;
typedef struct cfish_Num cfish_Num;
typedef struct cfish_FloatNum cfish_FloatNum;
typedef struct cfish_Float32 cfish_Float32;
typedef struct cfish_Float64 cfish_Float64;
typedef struct cfish_IntNum cfish_IntNum;
typedef struct cfish_Integer32 cfish_Integer32;
typedef struct cfish_Integer64 cfish_Integer64;
typedef struct cfish_BoolNum cfish_BoolNum;
typedef struct cfish_VArray cfish_VArray;
typedef struct cfish_ByteBuf cfish_ByteBuf;
typedef struct cfish_ViewByteBuf cfish_ViewByteBuf;
typedef struct cfish_TestBatch cfish_TestBatch;
typedef struct cfish_TestSuiteRunner cfish_TestSuiteRunner;
typedef struct cfish_TestFormatter cfish_TestFormatter;
typedef struct cfish_TestFormatterCF cfish_TestFormatterCF;
typedef struct cfish_TestFormatterTAP cfish_TestFormatterTAP;
typedef struct cfish_TestSuite cfish_TestSuite;
typedef struct cfish_TestBatchRunner cfish_TestBatchRunner;
typedef struct cfish_Method cfish_Method;
typedef struct cfish_LockFreeRegistry cfish_LockFreeRegistry;
typedef struct cfish_Hash cfish_Hash;
typedef struct cfish_HashTombStone cfish_HashTombStone;
typedef struct cfish_CharBuf cfish_CharBuf;
typedef struct cfish_Err cfish_Err;

#define CFISH_UNUSED_VAR(var) ((void)var)
#define CFISH_UNREACHABLE_RETURN(type) return (type)0

/* Generic method pointer.
 */
typedef void
(*cfish_method_t)(const void *vself);

/* Access the function pointer for a given method from the class.
 */
#define CFISH_METHOD_PTR(_class, _full_meth) \
     ((_full_meth ## _t)cfish_method(_class, _full_meth ## _OFFSET))

static CFISH_INLINE cfish_method_t
cfish_method(const void *klass, size_t offset) {
    union { char *cptr; cfish_method_t *fptr; } ptr;
    ptr.cptr = (char*)klass + offset;
    return ptr.fptr[0];
}

typedef struct cfish_Dummy {
   CFISH_OBJ_HEAD
   void *klass;
} cfish_Dummy;

/* Access the function pointer for a given method from the object.
 */
static CFISH_INLINE cfish_method_t
cfish_obj_method(const void *object, size_t offset) {
    cfish_Dummy *dummy = (cfish_Dummy*)object;
    return cfish_method(dummy->klass, offset);
}

/* Access the function pointer for the given method in the
 * superclass. */
#define CFISH_SUPER_METHOD_PTR(_class, _full_meth) \
     ((_full_meth ## _t)cfish_super_method(_class, \
                                           _full_meth ## _OFFSET))

extern CFISH_VISIBLE size_t cfish_Class_offset_of_parent;
static CFISH_INLINE cfish_method_t
cfish_super_method(const void *klass, size_t offset) {
    char *class_as_char = (char*)klass;
    cfish_Class **parent_ptr
        = (cfish_Class**)(class_as_char + cfish_Class_offset_of_parent);
    return cfish_method(*parent_ptr, offset);
}

/* Structs for Class initialization.
 */

typedef struct cfish_NovelMethSpec {
    size_t         *offset;
    const char     *name;
    cfish_method_t  func;
    cfish_method_t  callback_func;
} cfish_NovelMethSpec;

typedef struct cfish_OverriddenMethSpec {
    size_t         *offset;
    size_t         *parent_offset;
    cfish_method_t  func;
} cfish_OverriddenMethSpec;

typedef struct cfish_InheritedMethSpec {
    size_t *offset;
    size_t *parent_offset;
} cfish_InheritedMethSpec;

typedef struct cfish_ClassSpec {
    cfish_Class **klass;
    cfish_Class **parent;
    const char   *name;
    size_t        ivars_size;
    size_t       *ivars_offset_ptr;
    uint32_t      num_novel_meths;
    uint32_t      num_overridden_meths;
    uint32_t      num_inherited_meths;
    const cfish_NovelMethSpec      *novel_meth_specs;
    const cfish_OverriddenMethSpec *overridden_meth_specs;
    const cfish_InheritedMethSpec  *inherited_meth_specs;
} cfish_ClassSpec;

#ifdef CFISH_USE_SHORT_NAMES
  #define UNUSED_VAR               CFISH_UNUSED_VAR
  #define UNREACHABLE_RETURN       CFISH_UNREACHABLE_RETURN
  #define METHOD_PTR               CFISH_METHOD_PTR
  #define SUPER_METHOD_PTR         CFISH_SUPER_METHOD_PTR
#endif

CFISH_VISIBLE void
cfish_bootstrap_inheritance();

CFISH_VISIBLE void
cfish_bootstrap_parcel();

void
cfish_init_parcel();

#ifdef __cplusplus
}
#endif

#endif /* CFISH_CFISH_PARCEL_H */



